*
*	multi music status display MMDSP v0.29 Rel.10
*
*			program parts of 'SYSTEM DISPLAY'
*

		.include	doscall.mac
		.include	iocscall.mac
		.include	mmdsp.equ
		.include	faldrv.equ


* Global Symbol ------------------------------- *

		.xref	_JnAhX
		.xref	HSCOPY_W
		.xref	PUT_PATTERN
		.xref	TEXT_ACCESS_ON
		.xref	TEXT_ACCESS_OFF
		.xref	TEXT48AUTO
		.xref	BG_LINE
		.xref	FAL_WORKADR
		.xref	DIGIT10_SUPPRESS
		.xref	DIGIT16
		.xref	TEXT_6_16
		.xref	DIGIT_10
		.xref	BG_PRINT


* Text Section -------------------------------- *

		.cpu	68000
		.text


*
*	rxrchrQl`jd
*@\FVXefBXvCiHjʂ
*óFȂ
*QlF
*

SYSDISP_MAKE::
		MOVEM.L	D0-D1/A0-A2,-(SP)

		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(text_palet+($100)-_JnAhX),A0
		LEA.L	TPALET_BLOCK0+($100),A1
		MOVE.L	#$200-$100,D0
		BSR	HSCOPY_W

		MOVEQ.L	#$02,D0				* MMDSP ̕
		MOVE.L	#$000D_0007,D1
		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(MMDSPTTL_STR-_JnAhX),A0
		LEA.L	$E0009C,A1
		BSR	PUT_PATTERN

		MOVEQ.L	#$02,D0
		BSR	TEXT_ACCESS_ON

		LEA.L	$E00CB6,A0			* b \
		BSR	PUT_BAR
		LEA.L	$E018B6,A0
		BSR	PUT_BAR
		LEA.L	$E024B6,A0
		BSR	PUT_BAR
		LEA.L	$E030B6,A0
		BSR	PUT_BAR
		LEA.L	$E0309D,A0
		BSR	PUT_BAR
		LEA.L	$E030AA,A0
		BSR	PUT_BAR
		LEA.L	$E0409D-($80*8),A0
		BSR	PUT_BAR

		BSR	TEXT_ACCESS_OFF

		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(SYSDISP_MES1-_JnAhX),A0
		BSR	TEXT48AUTO
		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(SYSDISP_MUSDAT-_JnAhX),A0
		BSR	TEXT48AUTO
		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(SYSDISP_MES2-_JnAhX),A0
		BSR	TEXT48AUTO
		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(PALET_STR-_JnAhX),A0
		BSR	TEXT48AUTO
		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(LOOPCNT_MES-_JnAhX),A0
		BSR	TEXT48AUTO

		LEA.L	$EBD500,A0
		MOVE.W	#$0170,D0
		MOVEQ.L	#$05,D1
		BSR	BG_LINE
		LEA.L	$C(A0),A0
		MOVE.W	#$0171,D0
		MOVEQ.L	#$39,D1
		BSR	BG_LINE

		MOVEQ.L	#$00,D0
		MOVE.W	DRV_MODE(A6),D0			* hCo\
		SUBQ.W	#1,D0
		LSL.W	#6,D0
		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(DRIVER_TITLE-_JnAhX),A0
		ADDA.W	D0,A0
		MOVE.L	#$0001_0002,D0
		LEA.L	$E01BA0,A1
		MOVE.L	#$0007_0007,D1
		BSR	PUT_PATTERN

* FALDRV ꏈ 97-05-11
		CMPI.W	#DRV_FALDRV,DRV_MODE(A6)
		BNE	SYSDISP_MAKE08
		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(FALINFO_STR-_JnAhX),A0
		BSR	TEXT48AUTO
*
		MOVEA.L	FAL_WORKADR(A6),A1
		MOVEA.L	MMDSP_TOPADR(A6),A0
		MOVEA.L	A0,A2
		ADDA.L	#(FAL_MERCDIS_STR-_JnAhX),A0
		TST.B	M_MERCV4_FLAG(A1)
		BEQ	SYSDISP_MAKE04
		LEA.L	(FAL_MERCEN_STR-FAL_MERCDIS_STR)(A0),A0
SYSDISP_MAKE04:
		BSR	TEXT48AUTO
		MOVEA.L	A2,A0
		ADDA.L	#(FAL_OPNA_STR-_JnAhX),A0
		TST.B	M_OPNA_MODE(A1)
		BEQ	SYSDISP_MAKE05
		LEA.L	(FAL_OPN_STR-FAL_OPNA_STR)(A0),A0
SYSDISP_MAKE05:
		BSR	TEXT48AUTO

* PCM DRIVER \ 97-04-01
SYSDISP_MAKE08:
		MOVEQ.L	#$00,D0
		MOVE.B	PCMDRV_TYPE(A6),D0
		MULU.W	#20,D0
		MOVEA.L	MMDSP_TOPADR(A6),A0
		ADDA.L	#(PCMDRVNAME-_JnAhX),A0
		ADDA.W	D0,A0
		BSR	TEXT48AUTO

		LEA.L	$EBC37A,A0			* oߎԂ ':'
		MOVE.W	#$0228,$00(A0)
		MOVE.W	#$0229,$80(A0)
		LEA.L	$EBC0C8,A0			* P
		MOVE.W	#$026E,D0
		MOVEQ.L	#$1B,D1
		BSR	BG_LINE
		LEA.L	$EBC8BA,A0			* Q
		MOVE.W	#$026E,D0
		MOVEQ.L	#$22,D1
		BSR	BG_LINE
		MOVEQ.L	#31,D1				* OtBbNg[
		BSR	GTONE_SET
		MOVE.B	GRAPH_MODE(A6),D1		* OtBbN[h
		BSR	SET_GMODE

		MOVE.W	ONTIME_WORK3(A6),D0
		MOVE.W	D0,SYS_ONTIME(A6)
		MOVE.W	D0,CLKLAMP(A6)

		CLR.W	CYCLECNT(A6)
		CLR.W	SYS_TIME(A6)
		MOVE.W	SYS_TEMPO(A6),D0
		NOT.W	D0
		MOVE.W	D0,TEMPOCHK(A6)
		MOVE.W	SYS_LOOP(A6),D0
		NOT.W	D0
		MOVE.W	D0,LOOPCHK(A6)

SYSDISP_MAKE2:
		MOVEM.L	(SP)+,D0-D1/A0-A2
		RTS

*
* 'b' \
*
PUT_BAR:
		MOVE.B	#$70,D0
		MOVEQ.L	#14-1,D1
PUT_BAR2:
		MOVE.B	D0,(A0)
		LEA.L	$80(A0),A0
		DBRA.W	D1,PUT_BAR2
		RTS

*
*	rxrsdlQchro
*@\FVXefBXvC\
*óFȂ
*QlFȃ^CgCCtH[[VCvȂ
*

SYSTEM_DISP::
		MOVEM.L	D0-D2/A0-A1/A6,-(SP)

		clr.w	STAT_OK(a6)
		addq.w	#1,CYCLECNT(A6)			* 莞Ԃ̃JEg\
*		bsr	L001c20
		MOVE.W	ONTIME_WORK3(A6),D0
		move.w	d0,d2
		sub.w	SYS_ONTIME(a6),d0
		cmp.w	CYCLETIM(A6),d0
		bcs	L004160
		add.w	d0,SYS_ONTIME(a6)
		move.w	CYCLECNT(a6),d0
		lsr.w	#3,d0
		lea.l	$EBC64A,A0
* CPU POWER Sɂ 97-04-07, 97-07-26, 97-10-29
		MOVEQ.L	#$04,D1				* moveq.l #3,d1
		BSR	DIGIT10_SUPPRESS
		clr.w	CYCLECNT(a6)

L004160:
		move.w	d2,d0
		sub.w	CLKLAMP(a6),d0
		cmpi.w	#50,d0
		bcs	L004180

		lea.l	$ebc1fa,a1			* ̃R_
		move.w	#$22a,(a1)
		move.w	#$22b,$80(a1)

		move.w	d2,CLKLAMP(a6)

L004180:
		IOCS	_TIMEGET			* ݎԕ\
		cmp.w	SYS_TIME(a6),d0
		beq	L00433a				* ׂĂ̕\͂Pbɍs

		move.w	d2,CLKLAMP(a6)

		lea.l	$ebc1f6,a1			* ̃R_
		move.w	#$228,4(a1)
		move.w	#$229,$84(a1)

		move.w	d0,SYS_TIME(a6)
		move.l	d0,d2

		moveq.l	#2,d1				* \
		move.l	d2,d0
		lsr.w	#8,d0
		lea.l	6(a1),a0
		bsr	DIGIT16

		move.l	d2,d0				* ԕ\
		swap.w	d0
		movea.l	a1,a0
		bsr	DIGIT16

		DRIVER	DRIVER_SYSSTAT
		move.w	#-1,STAT_OK(a6)

		movea.l	SYS_TITLE(a6),a0		* ȃ^Cgr
		lea.l	MDXCHCK(a6),a1
		move.w	TITLELEN(a6),d1
		subq.w	#1,d1
L0041da:
		move.b	(a0)+,d0
		beq	L0041e8
		cmp.b	(a1)+,d0
		dbne	d1,L0041da
		beq	L004246
		bra	L0041ec
L0041e8:
		tst.b	(a1)
		beq	L004246
L0041ec:
		movea.l	SYS_TITLE(a6),a0		* obt@ɃRs[
		lea.l	MDXCHCK(a6),a1
		move.w	TITLELEN(a6),d1
		subq.w	#1,d1
L0041fa:
		move.b	(a0)+,(a1)+
		dbeq	d1,L0041fa
		clr.b	(a1)

		lea.l	MDXCHCK(a6),a0			* Rg[R[h𔲂
		lea.l	MDXTITLE(a6),a1
		moveq.l	#$4c,d1
L00420c:
		move.b	(a0)+,d0
		beq	L004226
		cmpi.b	#$d,d0
		beq	L004226
		cmpi.b	#$20,d0
		bcc	L00421e
		moveq.l	#$20,d0
L00421e:
		move.b	d0,(a1)+
		dbra	d1,L00420c
		bra	L00422e
L004226:
		move.b	#$20,(a1)+
		dbra	d1,L004226
L00422e:
		clr.b	(a1)
		moveq.l	#3,d0
		moveq.l	#0,d1
		lea.l	MDXTITLE(a6),a0
		lea.l	$e0a206,a1
		bsr	TEXT_6_16

		bsr	CLEAR_PASSTIME			* oߎԃNA

*
* TIMER-B CYCLE
*
L004246:
		move.w	SYS_TEMPO(a6),d0
		cmp.w	TEMPOCHK(a6),d0
		beq	L004260
		move.w	d0,TEMPOCHK(a6)
		LEA.L	$EBC4FA,A0
		MOVEQ.L	#$03,D1
		bsr	DIGIT_10

*
* LOOP COUNTER
*
L004260:
		move.w	SYS_LOOP(a6),d0
		cmp.w	LOOPCHK(a6),d0
		beq	L0042a0
		move.w	d0,LOOPCHK(a6)
		lea.l	$ebc678,a0
		cmpi.w	#9999,d0
		bhi	L004282
		moveq.l	#4,d1
		bsr	DIGIT_10
		bra	L0042a0

L004282:
		move.l	#$02360236,d0
		move.l	d0,(a0)
		move.l	d0,4(a0)
		move.l	#$023f023f,d0
		move.l	d0,$80(a0)
		move.l	d0,$84(a0)

L0042a0:
		move.w	BLANK(a6),d0			* uNł
		ble	L0042ca
		lea.l	$ebc376,a0
		move.l	#$2360236,(a0)+			* 󔒕\
		move.l	#$23f023f,$7c(a0)
		addq.l	#2,a0
		sub.w	BLANK_TIME(a6),d0		* uNc莞ԕ\
		neg.w	d0
		moveq.l	#2,d1
		bsr	DIGIT_10
		bra	L004306
L0042ca:
		tst.w	PLAY_FLAG(a6)
		beq	L0042e2
		move.w	SYS_PASSTM(a6),d0
		addq.w	#1,d0
		cmpi.w	#3600,d0
		bcs	L0042de
		moveq.l	#0,d0
L0042de:
		move.w	d0,SYS_PASSTM(a6)
L0042e2:
		moveq.l	#0,d0
		move.w	SYS_PASSTM(a6),d0		* oߎԕ\
		bpl	L0042ec
		moveq.l	#0,d0
L0042ec:
		divu.w	#60,d0
		lea.l	$ebc376,a0
		moveq.l	#2,d1
		bsr	DIGIT_10
		addq.l	#6,a0
		swap.w	d0
		bsr	DIGIT_10

*
* tԂ̂kbc\[`
*
L004306:
		tst.w	PLAY_FLAG(a6)			* tԕ\
		sne.b	d1
		tst.w	PLAYEND_FLAG(a6)
		sne.b	d0
		andi.w	#%0000_0001,d1			* 0:PAUSE, 1:PLAY, 2:END, 3:----
		andi.w	#%0000_0010,d0
		or.w	d1,d0
		lsl.w	#4,d0
		lea.l	L004340(pc,d0.w),a0
		move.w	#$200,d0
		lea.l	$ebc65e,a1
		bsr	BG_PRINT
		addq.l	#8,a0
		lea.l	$80(a1),a1
		bsr	BG_PRINT

L00433a:
		MOVEM.L	(SP)+,D0-D2/A0-A1/A6
		RTS

L004340:
		.dc.b	$30,$30,$33,$34,$34,$00,$00,$00		* PAUSE
		.dc.b	$3e,$3d,$37,$3a,$39,$00,$00,$00
		.dc.b	$30,$35,$30,$33,$36,$00,$00,$00		* PLAY
		.dc.b	$3e,$23,$3d,$3a,$3f,$00,$00,$00
		.dc.b	$36,$36,$36,$36,$36,$00,$00,$00		* -----
		.dc.b	$3f,$3f,$3f,$3f,$3f,$00,$00,$00
		.dc.b	$36,$36,$36,$36,$36,$00,$00,$00		* -----
		.dc.b	$3f,$3f,$3f,$3f,$3f,$00,$00,$00


*==================================================
*oߎԂ̃NA
*==================================================

CLEAR_PASSTIME::
		MOVEM.L	D0-D1/A0,-(SP)
		MOVE.W	#-1,SYS_PASSTM(A6)
		LEA.L	$EBC376,A0
		MOVEQ.L	#0,D0
		MOVEQ.L	#2,D1
		BSR	DIGIT_10
		ADDQ.L	#6,A0
		BSR	DIGIT_10
		MOVEM.L	(SP)+,D0-D1/A0
		RTS


*==================================================
*OtBbN[hݒ
*	d1.b <- graph mode(0-4)
*		0:OtBbNȂ
*		1:dˍ
*		2:
*		3:OtBbNZ
*		4:OtBbN̂
*==================================================


SET_GMODE::
		movem.l	d0-d1/a0,-(sp)
		cmpi.b	#4,d1
		bhi	L0043fe
		move.b	d1,GRAPH_MODE(a6)

		moveq.l	#0,d0
		move.w	d1,d0
		lsl.w	#2,d0				* WX^Ƀf[^Zbg
		lea.l	L004404(pc,d0.w),a0
		move.b	VCTRL_R1,d0
		andi.b	#$c0,d0
		or.w	(a0)+,d0
		move.b	d0,VCTRL_R1
		move.w	(a0)+,VCTRL_R2

		move.w	#$210e,d0			* fW^̃pbgύX
		cmpi.b	#1,d1
		beq	L0043e6
		cmpi.b	#4,d1
		bne	L0043e8
L0043e6:
		moveq.l	#0,d0
L0043e8:
		move.w	d0,$e82200+$044			* afpbgH

		tst.b	GRAPH_MODE(a6)			* OtBbNȂȊÕ[h
		beq	L0043fe
		tst.w	GTONE(a6)			* OtBbNg[OȂ
		bne	L0043fe
		moveq.l	#$10,d1				* n[tg[ɂ
		bsr	GTONE_SET
L0043fe:
		movem.l	(sp)+,d0-d1/a0
		rts

L004404:
		.dc.w	$0012,$0060,$0012,$006f
		.dc.w	$0021,$196f,$0024,$006f
		.dc.w	$0024,$000f


*==================================================
*OtBbNg[ύX
*==================================================

*OtBbNg[Abv

GTONE_UP::
		move.l	d1,-(sp)
		move.w	GTONE(a6),d1
		addq.w	#1,d1
		bsr	GTONE_SET
		move.l	(sp)+,d1
		rts

*OtBbNg[_E

GTONE_DOWN::
		move.l	d1,-(sp)
		move.w	GTONE(a6),d1
		subq.w	#1,d1
		bsr	GTONE_SET
		move.l	(sp)+,d1
		rts

*OtBbNg[ݒ
*	d1.w <- g[(0-31)

GTONE_SET::
_004434::
		movem.l	d0-d1/a0-a1,-(sp)
		cmpi.w	#$1f,d1
		bhi	L00446a
		move.w	d1,GTONE(a6)
		movea.l	GTONE_TBL(a6),a0
		lsl.w	#8,d1
		add.w	d1,d1
		lea.l	(a0,d1.w),a0
		lea.l	$e82000,a1
		moveq.l	#$f,d0
L004456:
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		move.l	(a0)+,(a1)+
		dbra	d0,L004456
L00446a:
		movem.l	(sp)+,d0-d1/a0-a1
		rts


*==================================================
*OtBbNXN[
*==================================================

GHOME::
		clr.l	GSCROL_X(a6)
		bra	GRAPH_SCROLL

GMOVE_UP::
		move.w	GSCROL_Y(A6),d0
		subq.w	#8,d0
		cmpi.w	#$3ff,d0
		bls	L004486
		move.w	#$3ff,d0
L004486:
		move.w	d0,GSCROL_Y(A6)
		bra	GRAPH_SCROLL

GMOVE_DOWN::
		move.w	GSCROL_Y(A6),d0
		addq.w	#8,d0
		cmpi.w	#$3ff,d0
		bls	L00449a
		clr.w	d0
L00449a:
		move.w	d0,GSCROL_Y(A6)
		bra	GRAPH_SCROLL

GMOVE_LEFT::
		move.w	GSCROL_X(a6),d0
		subq.w	#8,d0
		cmpi.w	#$3ff,d0
		bls	L0044b0
		move.w	#$3ff,d0
L0044b0:
		move.w	d0,GSCROL_X(a6)
		bra	GRAPH_SCROLL

GMOVE_RIGHT::
		move.w	GSCROL_X(a6),d0
		addq.w	#8,d0
		cmpi.w	#$3ff,d0
		bls	L0044c4
		clr.w	d0
L0044c4:
		move.w	d0,GSCROL_X(a6)

GRAPH_SCROLL:
		movem.l	d0/a0,-(sp)
		lea.l	$e80018,a0
		move.l	GSCROL_X(a6),d0
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		movem.l	(sp)+,d0/a0
		rts


*==================================================
*afp^[I
*	d1.w <- p^[ԍ(0-4)
*==================================================

BG_SEL::
		movem.l	d0-d1/a0,-(sp)
		moveq.l	#0,d0
		subq.w	#1,d1
		bmi	L0044f8
		addi.w	#$224,d1
		move.w	d1,d0
		swap.w	d0
		move.w	d1,d0
L0044f8:
		lea.l	$ebe000,a0
		move.w	#$1ef,d1
L004502:
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		dbra	d1,L004502
		lea.l	$ebea40,a0
		bsr	L004524
		lea.l	$ebeec0,a0
		bsr	L004524
		movem.l	(sp)+,d0-d1/a0
		rts

L004524:
		moveq.l	#0,d0
		moveq.l	#6,d1
L004528:
		swap.w	d1
		move.w	#3,d1
L00452e:
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		move.l	d0,(a0)+
		dbra	d1,L00452e
		lea.l	$40(a0),a0
		swap.w	d1
		dbra	d1,L004528
		rts

*==================================================
*pbgAj
*==================================================

PALET_ANIM::
		tst.w	PLAY_FLAG(a6)
		beq	palet_anim90
		movem.l	d0-d1/a0,-(sp)
		lea	palet_wait(pc),a0
		subq.w	#1,(a0)
		bcc	palet_anim80
		move.w	#1,(a0)
		LEA.L	$E82200+$A*32+30,a0
		move.l	-(a0),2(a0)
		move.l	-(a0),2(a0)
		move.l	-(a0),2(a0)
		move.l	-(a0),2(a0)
		move.l	-(a0),2(a0)
		move.l	-(a0),2(a0)
		move.l	-(a0),2(a0)
		move.w	palet_cnt(pc),d0
		move.w	palet_tbl(pc,d0.w),(a0)
		addq.w	#2,d0
		move.w	palet_tbl(pc,d0.w),d1
		bne	palet_anim10
		moveq	#0,d0
palet_anim10:
		lea	palet_cnt(pc),a0
		move.w	d0,(a0)
palet_anim80:
		movem.l	(sp)+,d0-d1/a0
palet_anim90:
		rts

palet_cnt:	.dc.w	0
palet_wait:	.dc.w	1

RGB_COL:	.macro	R1,G1,B1,dm1,R2,G2,B2,dm2,R3,G3,B3,dm3,R4,G4,B4
		.dc.w	B1*2+R1*64+G1*2048
		.dc.w	B2*2+R2*64+G2*2048
		.dc.w	B3*2+R3*64+G3*2048
		.dc.w	B4*2+R4*64+G4*2048
		.endm

palet_tbl:
		RGB_COL	01,01,01,__,02,02,02,__,03,03,03,__,04,04,04
		RGB_COL	05,05,05,__,06,06,06,__,07,07,07,__,08,08,08
		RGB_COL	09,09,09,__,10,10,10,__,11,11,11,__,12,12,12
		RGB_COL	13,13,13,__,14,14,14,__,15,15,15,__,16,16,16
		RGB_COL	17,17,17,__,18,18,18,__,19,19,19,__,20,20,20
		RGB_COL	21,21,21,__,22,22,22,__,23,23,23,__,24,24,24
		RGB_COL	25,25,25,__,26,26,26,__,27,27,27,__,28,28,28
		RGB_COL	29,29,29,__,30,30,30,__,31,31,31,__,30,30,30
		RGB_COL	29,29,29,__,28,28,28,__,27,27,27,__,26,26,26
		RGB_COL	25,25,25,__,24,24,24,__,23,23,23,__,22,22,22
		RGB_COL	21,21,21,__,20,20,20,__,19,19,19,__,18,18,18
		RGB_COL	17,17,17,__,16,16,16,__,15,15,15,__,14,14,14
		RGB_COL	13,13,13,__,12,12,12,__,11,11,11,__,10,10,10
		RGB_COL	09,09,09,__,08,08,08,__,07,07,07,__,06,06,06
		RGB_COL	05,05,05,__,04,04,04,__,03,03,03,__,02,02,02
		RGB_COL	01,01,01,__,01,01,01,__,01,01,01,__,01,01,01
		RGB_COL	01,01,01,__,01,01,01,__,01,01,01,__,01,01,01
		RGB_COL	01,01,01,__,01,01,01,__,01,01,01,__,01,01,01
		RGB_COL	01,01,01,__,01,01,01,__,01,01,01,__,01,01,01
		RGB_COL	01,01,01,__,01,01,01,__,01,01,01,__,00,00,00



		.DATA

text_palet::
*			 GGGGG RRRRR BBBBB I
		.dc.w	%00001_00001_00001_1		* wi
		.dc.w	%01010_01010_10101_0		* FiÁj
		.dc.w	%10010_10000_11111_1		* Fij
		.dc.w	%11010_11010_11010_1		* Fit^Cgj
		.dc.w	%11111_11111_11111_0		* Օ @,K,D,etc
		.dc.w	%11111_11111_11111_0		* }EXJ[\
		.dc.w	%11111_11111_11111_0		* Fijƃ}EXJ[\̏dȂ
		.dc.w	%11111_11111_11111_0		*
		.dc.w	%00001_00001_00001_1
		.dc.w	%01000_00001_01101_0
		.dc.w	%01101_01101_10101_0
		.dc.w	%01100_01100_01100_0
		.dc.w	%00001_00001_00001_0
		.dc.w	%01000_01000_01101_0
		.dc.w	%01101_01101_10101_0
		.dc.w	%01100_01100_01100_0		* 16
		.dc.w	$0000,$0000,$0000,$0000		* 60*4=240+16=256blocks
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0002,$2958,$6330,$18ce
		.dc.w	$0000,$18ce,$210e,$843e
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$39dc
		.dc.w	$0000,$94be,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$8840,$a880,$da40,$fb00
		.dc.w	$0000,$0002,$0000,$0000
		.dc.w	$318e,$5296,$631a,$739e
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$739e,$94a6,$c632,$e73a
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$ad6c
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$108c,$843e
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$739c
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$108c,$843e
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$2a6c,$084a
		.dc.w	$0000,$0002,$0000,$0000
		.dc.w	$18c8,$294c,$318e,$39d0
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$39d0,$4a54,$631a,$739e
		.dc.w	$0000,$0002,$0000,$0000
		.dc.w	$18c8,$294c,$318e,$39d0
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$39d0,$4a54,$631a,$739e
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$b5ae,$0000,$b5ae
		.dc.w	$0000,$b5ae,$0000,$b5ae
		.dc.w	$0000,$b5ae,$0000,$b5ae
		.dc.w	$0000,$b5ae,$0000,$b5ae
		.dc.w	$0000,$0000,$b5ae,$b5ae
		.dc.w	$0000,$0000,$b5ae,$b5ae
		.dc.w	$0000,$0000,$b5ae,$b5ae
		.dc.w	$0000,$0000,$b5ae,$b5ae
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$b5ae,$b5ae,$b5ae,$b5ae
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$b5ae,$b5ae,$b5ae,$b5ae
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$0000,$0000,$0000,$0000
		.dc.w	$b5ae,$b5ae,$b5ae,$b5ae
		.dc.w	$b5ae,$b5ae,$b5ae,$b5ae

MMDSPTTL_STR:
		.DC.W	%0000001100001100,%0110000110011111,%1110000111111111,%0111111111000000
		.DC.W	%0000011110011110,%1111001111011111,%1111001111111111,%0111111111100000
		.DC.W	%0000011111111110,%1111111111011000,%0011001100000000,%0110000001100000
		.DC.W	%0000011011110110,%1101111011011000,%0001101100000000,%0110000001100000
		.DC.W	%0000011001100110,%1100110011011000,%0001101100000000,%0110000001100000
		.DC.W	%0000011000000110,%1100000011011000,%0001101111111110,%0110000001100000
		.DC.W	%0000011000000110,%1100000011011000,%0001100111111111,%0111111111100000
		.DC.W	%0000011000000110,%1100000011011000,%0001100000000011,%0111111111000000
		.DC.W	%0000011000000110,%1100000011011000,%0001100000000011,%0110000000000000
		.DC.W	%0000011000000110,%1100000011011000,%0011000000000011,%0110000000000000
		.DC.W	%0000011000000110,%1100000011011111,%1111001111111111,%0110000000000000
		.DC.W	%0000011000000110,%1100000011011111,%1110001111111110,%0110000000000000
		.DC.W	%0000000000000000,%0000000000000000,%0000000000000000,%0000000000000000
		.DC.W	%0000011111111111,%1111111111111111,%1111111111111111,%1111111111100000

SYSDISP_MES1:
*			 +-------------------------- ݃eLXgv[(0:TABLE END)
*			 |   +---------------------- l߂邩(0:l߂)
*			 |   |   +------------------ wW
*			 |   |   |   +-------------- wW
*			 |   |   |   |   +---------- xW
*			 |   |   |   |   |   +------ xW
*			 |   |   |   |   |   |   +-- 
*			 |   |   |   |   |   |   |
*			PLN,SPF, X , X2, Y , Y2,STR,0
		.DC.B	$01,$00,$24,$00,$00,$00,'Ver. 0.29 ',RELNUM,' COPYRIGHT 1991-97 MiahMie, Gao / Fu-., BEL.',0
		.DC.B	$02,$00,$24,$00,$00,$08,'SYNTHETIC DISPLAY for VARIOUS MUSIC DRIVERS.',0
		.DC.B	$02,$00,$39,$06,$00,$08,'CONTROL PANEL',0
		.DC.B	$01,$00,$1D,$01,$00,$38,'DRIVER:',0
		.DC.B	$01,$00,$1D,$01,$00,$44,'ADPCM',0
		.DC.B	$01,$00,$1F,$07,$00,$44,':',0
		.DC.B	$01,$00,$27,$03,$00,$38,'GRAPHIC',0
		.DC.B	$01,$00,$1D,$01,$00,$50,'BACKGROUND PATTERN',0
		.DC.B	$01,$00,$27,$01,$00,$50,'OFF',0
		.DC.B	0

SYSDISP_MUSDAT:
		.DC.B	$01,$00,$00,$00,$01,$44,'NOW PLAYING',0
		.DC.B	$01,$00,$00,$01,$01,$4C,' MUSIC DATA',$1C,0
		.DC.B	0

SYSDISP_MES2:
		.DC.B	$02,$00,$37,$03,$00,$18,'DIGITAL',0
		.DC.B	$02,$00,$37,$07,$00,$20,'CLOCK',$7F,0
		.DC.B	$02,$00,$37,$03,$00,$30,'PASSED',0
		.DC.B	$02,$00,$38,$05,$00,$38,'TIME',$7F,0
		.DC.B	$02,$00,$37,$01,$00,$48,'TIMER-B',0
		.DC.B	$02,$00,$37,$07,$00,$50,'CYCLE',$7F,0
*		.DC.B	$02,$00,$1e,$05,$00,$60,'CPU CYCLE',0
*		.DC.B	$02,$00,$1e,$00,$00,$68,'PERCENTAGE',$7F,0
		.DC.B	$02,$00,$1F,$01,$00,$60,'CPU POWER',0
		.DC.B	$02,$00,$1E,$00,$00,$68,'PERFORMANCE',$7F,0
		.DC.B	$02,$00,$2b,$02,$00,$60,'DRIVER',0
		.DC.B	$02,$00,$2b,$00,$00,$68,'STATUS',$7F,0
		.DC.B	0

PALET_STR:
		.DC.B	$02,$00,$1E,$02,$00,$78,'MMDSP DISPLAY',0
		.DC.B	$02,$00,$1E,$00,$00,$80,'COLOR PALETTE',$7F,0
		.DC.B	$02,$00,$25,$04,$00,$80,'No.',0
		.DC.B	$02,$00,$29,$01,$00,$80,'R.',0
		.DC.B	$02,$00,$2C,$01,$00,$80,'G.',0
		.DC.B	$02,$00,$2F,$01,$00,$80,'B.',0
		.DC.B	0

LOOPCNT_MES:
		.DC.B	$02,$00,$38,$03,$00,$60,'LOOP',0
		.DC.B	$02,$00,$36,$07,$00,$68,'COUNTER',$7F,0
		.DC.B	0
		.EVEN

*
* DRIVER TITLE
*
DRIVER_TITLE::
* MXDRV
		.DC.L	%00100000101000010111110011111001,%00001000000000000000000000000000
		.DC.L	%00100000100100100100001010000101,%00001000000000000000000000000000
		.DC.L	%00110001100100100100001010000101,%00001000000000000000000000000000
		.DC.L	%00110001100011000100001010000100,%10010000000000000000000000000000
		.DC.L	%00101010100011000100001010111000,%10010000000000000000000000000000
		.DC.L	%00101010100100100100001010000100,%10010000000000000000000000000000
		.DC.L	%00100100100100100100001010000100,%01000000000000000000000000000000
		.DC.L	%00100100101000010101110010000100,%01100000000000000000000000000000

* MADRV
		.DC.L	%00100000100011000111110011111001,%00001000000000000000000000000000
		.DC.L	%00100000100011000100001010000101,%00001000000000000000000000000000
		.DC.L	%00110001100100100100001010000101,%00001000000000000000000000000000
		.DC.L	%00110001100100100100001010000100,%10010000000000000000000000000000
		.DC.L	%00101010100100100100001010111000,%10010000000000000000000000000000
		.DC.L	%00101010101000010100001010000100,%10010000000000000000000000000000
		.DC.L	%00100100101011110100001010000100,%01000000000000000000000000000000
		.DC.L	%00100100101000010101110010000100,%01100000000000000000000000000000

* MLD
		.DC.L	%00100000101000000111110000000000,%00000000000000000000000000000000
		.DC.L	%00100000101000000100001000000000,%00000000000000000000000000000000
		.DC.L	%00110001101000000100001000000000,%00000000000000000000000000000000
		.DC.L	%00110001101000000100001000000000,%00000000000000000000000000000000
		.DC.L	%00101010101000000100001000000000,%00000000000000000000000000000000
		.DC.L	%00101010101000000100001000000000,%00000000000000000000000000000000
		.DC.L	%00100100101000000100001000000000,%00000000000000000000000000000000
		.DC.L	%00100100100111110101110000000000,%00000000000000000000000000000000

* RCD
		.DC.L	%00111110001111101111100000000000,%00000000000000000000000000000000
		.DC.L	%00100001010000001000010000000000,%00000000000000000000000000000000
		.DC.L	%00100001010000001000010000000000,%00000000000000000000000000000000
		.DC.L	%00100001010000001000010000000000,%00000000000000000000000000000000
		.DC.L	%00101110010000001000010000000000,%00000000000000000000000000000000
		.DC.L	%00100001010000001000010000000000,%00000000000000000000000000000000
		.DC.L	%00100001010000001000010000000000,%00000000000000000000000000000000
		.DC.L	%00100001001111101011100000000000,%00000000000000000000000000000000

* ZMUSIC
		.DC.L	%00111111010000010100001001111101,%00111110000000000000000000000000
		.DC.L	%00000001010000010100001010000001,%01000000000000000000000000000000
		.DC.L	%00000010011000110100001010000001,%01000000000000000000000000000000
		.DC.L	%00000100011000110100001001111001,%01000000000000000000000000000000
		.DC.L	%00001000010101010100001000000101,%01000000000000000000000000000000
		.DC.L	%00010000010101010100001000000101,%01000000000000000000000000000000
		.DC.L	%00100000010010010100001000000101,%01000000000000000000000000000000
		.DC.L	%00111111010010010011110011111001,%00111110000000000000000000000000

* MCDRV
		.DC.L	%00100000100111110111110011111001,%00001000000000000000000000000000
		.DC.L	%00100000101000000100001010000101,%00001000000000000000000000000000
		.DC.L	%00110001101000000100001010000101,%00001000000000000000000000000000
		.DC.L	%00110001101000000100001010000100,%10010000000000000000000000000000
		.DC.L	%00101010101000000100001010111000,%10010000000000000000000000000000
		.DC.L	%00101010101000000100001010000100,%10010000000000000000000000000000
		.DC.L	%00100100101000000100001010000100,%01000000000000000000000000000000
		.DC.L	%00100100100111110101110010000100,%01100000000000000000000000000000

* FALDRV
		.DC.L	%00111110011110010000001111100111,%11001000010000000000000000000000
		.DC.L	%01000000100001010000001000010100,%00101000010000000000000000000000
		.DC.L	%01000000100001010000001000010100,%00101000010000000000000000000000
		.DC.L	%01000000100001010000001000010100,%00100100100000000000000000000000
		.DC.L	%01111100101111010000001000010101,%11000100100000000000000000000000
		.DC.L	%01000000100001010000001000010100,%00100100100000000000000000000000
		.DC.L	%01000000100001010000001000010100,%00100010000000000000000000000000
		.DC.L	%01000000100001001111101011100100,%00100011000000000000000000000000

* SORCERIAN (PC-88SR)
		.DC.L	%00110001100111000110011110111001,%00110010010000000000000000000000
		.DC.L	%01001010010100101001010000100101,%01001011010000000000000000000000
		.DC.L	%01000010010100101000010000100101,%01001011010001000100000000000000
		.DC.L	%00110010010100101000011100100101,%01001010110010101010000000000000
		.DC.L	%00001010010101001000010000101001,%01011010110001000100000000000000
		.DC.L	%00001010010100101000010000100101,%01001010110010101010000000000000
		.DC.L	%01001010010100101001010000100101,%01001010010010101010000000000000
		.DC.L	%00110001100100100110011110100101,%01001010010001000100000000000000

* SORCERIAN (X1turbo)
		.DC.L	%00110001100111000110011110111001,%00110010010000000000000000000000
		.DC.L	%01001010010100101001010000100101,%01001011010000000000000000000000
		.DC.L	%01000010010100101000010000100101,%01001011010010100100000000000000
		.DC.L	%00110010010100101000011100100101,%01001010110010101100000000000000
		.DC.L	%00001010010101001000010000101001,%01011010110001000100000000000000
		.DC.L	%00001010010100101000010000100101,%01001010110001000100000000000000
		.DC.L	%01001010010100101001010000100101,%01001010010010100100000000000000
		.DC.L	%00110001100100100110011110100101,%01001010010010100100000000000000

* MNDRV
		.DC.L	%00100000101000010111110011111001,%00001000000000000000000000000000
		.DC.L	%00100000101100010100001010000101,%00001000000000000000000000000000
		.DC.L	%00110001101010010100001010000101,%00001000000000000000000000000000
		.DC.L	%00110001101010010100001010000100,%10010000000000000000000000000000
		.DC.L	%00101010101001010100001010111000,%10010000000000000000000000000000
		.DC.L	%00101010101001010100001010000100,%10010000000000000000000000000000
		.DC.L	%00100100101000110100001010000100,%01000000000000000000000000000000
		.DC.L	%00100100101000010101110010000100,%01100000000000000000000000000000


*
* for FALDRV ONLY
*
FALINFO_STR::
		.DC.B	$01,$00,$35,$05,$00,$78,'Mercury OUTPUT:',0
		.DC.B	$01,$00,$35,$07,$00,$80,'EMULATION MODE:',0
		.DC.B	0

FAL_MERCDIS_STR::
		.DC.B	$02,$00,$3C,$07,$00,$78,'DISABLE',0,0
FAL_MERCEN_STR::
		.DC.B	$02,$00,$3C,$07,$00,$78,'ENABLE',0,0

FAL_OPNA_STR::
		.DC.B	$02,$00,$3C,$07,$00,$80,'OPNA',0,0
FAL_OPN_STR::
		.DC.B	$02,$00,$3C,$07,$00,$80,'OPN ',0,0

*
* PCM DRIVER NAME
*
PCMDRVNAME::
		.DC.B	$02,$00,$20,$03,$00,$44,'- INTERNAL -',0,0
		.DC.B	$02,$00,$20,$03,$00,$44,'- MPCM -    ',0,0
		.DC.B	$02,$00,$20,$03,$00,$44,'- PCM8++ -  ',0,0
		.DC.B	$02,$00,$20,$03,$00,$44,'- MiaPie -  ',0,0
		.DC.B	$02,$00,$20,$03,$00,$44,'- PCM8A -   ',0,0
		.DC.B	$02,$00,$20,$03,$00,$44,'- RDN -     ',0,0
		.DC.B	$02,$00,$20,$03,$00,$44,'- PCM8 -    ',0,0



		.END
