*
*	multi music status display MMDSP v0.29 Rel.10
*
*			program parts of 'DRIVER'
*

		.include	doscall.mac
		.include	iocscall.mac
		.include	mmdsp.equ


* Global Symbol ------------------------------- *

		.xref	MXDRV_ENTRY
		.xref	madrv_jump_table
		.xref	MLD_ENTRY
		.xref	rcd_jump_table
		.xref	zmusic_jump_table
		.xref	MCDRV_ENTRY
		.xref	FALDRV_ENTRY
		.xref	SORC88_ENTRY
		.xref	SORCX1_ENTRY
		.xref	MNDRV_ENTRY


* Text Section -------------------------------- *

		.cpu	68000
		.text


*==================================================
* DRIVER e[u
*==================================================

ENTRY_TABLE:
		.DC.W	MXDRV_ENTRY-ENTRY_TABLE
		.DC.W	madrv_jump_table-ENTRY_TABLE
		.DC.W	MLD_ENTRY-ENTRY_TABLE
		.DC.W	rcd_jump_table-ENTRY_TABLE
		.DC.W	zmusic_jump_table-ENTRY_TABLE
		.DC.W	MCDRV_ENTRY-ENTRY_TABLE
		.DC.W	FALDRV_ENTRY-ENTRY_TABLE
		.DC.W	SORC88_ENTRY-ENTRY_TABLE
		.DC.W	SORCX1_ENTRY-ENTRY_TABLE
		.DC.W	MNDRV_ENTRY-ENTRY_TABLE
		.DC.W	0


*==================================================
* DRIVER 풓`FbN
*	풓ĂhCo`FbN
*	DRV_MODE(A6) <- whCoԍ (0Ȃ玩I)
*	D0.w -> hCoԍiOȂ풓ĂȂj
*	Ql: DRV_MODE(A6),DRV_ENTRY(A6)ɂL^
*==================================================

search_driver::
		MOVE.L	D1,-(SP)
		MOVE.W	DRV_MODE(A6),D0
		BEQ	search_driver10

search_driver01:
		BSR	check_driver
		BMI	search_driver90
		BRA	search_driver30

search_driver10:
		MOVEQ.L	#1,D1
search_driver20:
		MOVE.W	D1,D0
		BSR	check_driver
		BEQ	search_driver90
		BPL	search_driver30
		ADDQ.W	#1,D1
		BRA	search_driver20
search_driver30:
		BSR	ext_driver_jobtbl
		MOVE.L	(SP)+,D1
		RTS
search_driver90:
		MOVEQ.L	#0,D0
		MOVE.L	(SP)+,D1
		RTS

*hCo풓`FbN
*	D0.w <- hCoԍ
*	D0.w -> hCoԍ(:풓ĂȂ 0:SĒ׏I)
*	a0.l -> hCoGgAhX

check_driver::
		MOVEM.L	D1/A1,-(SP)
		LEA.L	ENTRY_TABLE(pc),A0
		MOVE.W	D0,D1
		SUBQ.W	#1,D0
		BMI	check_driver90
		ADD.W	D0,D0
		MOVE.W	(A0,D0.W),D0
		BEQ	check_driver90
		LEA.L	(A0,D0.W),A0
		MOVE.W	(A0),D0
		JSR	(A0,D0.W)
		TST.L	D0
		BMI	check_driver90
		MOVE.W	D1,D0
check_driver90:
		MOVEM.L	(SP)+,D1/A1
		RTS

*
* hCȍe[u $2ac(A6).l`$2e8(A6).l ɓWJ
*
ext_driver_jobtbl:
		MOVEM.L	D0/A0-A2,-(SP)
		MOVE.W	D0,DRV_MODE(A6)
		MOVE.L	A0,DRV_ENTRY(A6)
		MOVEA.L	A0,A2
		MOVEQ.L	#16-1,D1
		LEA.L	DRIVER_JMPTBL(A6),A1
ext_driver_jobtbl10:
		MOVEQ.L	#0,D0
		MOVE.W	(A0)+,D0
		ADD.L	A2,D0
		MOVE.L	D0,(A1)+
		DBRA.W	D1,ext_driver_jobtbl10
		MOVEM.L	(SP)+,D0/A0-A2
		RTS


*==================================================
* DRIVER Xe[^X
*	SẴgbN̕ωrbg𗧂Ă
*==================================================

STATUS_INIT::
	*DRIVER_TRKSTATrefresh_subĂ
		MOVEM.L	D0-D1/A0-A1,-(SP)
		LEA.L	DRIVER_JMPTBL+16(A6),A1
		MOVE.L	(A1),REF_TRSTWORK(A6)
		LEA.L	refresh_sub(PC),A0
		MOVE.L	A0,(A1)

		LEA.L	TRACK_STATUS+T_KEYONSTAT(A6),A0
		MOVEQ.L	#0,D0
		MOVEQ.L	#32-1,D1
status_init10:
		MOVE.B	D0,(A0)
		LEA.L	TRST(A0),A0
		DBRA.W	D1,status_init10
		MOVEM.L	(SP)+,D0-D1/A0-A1
		RTS

refresh_sub:
		*{Ƃ̃[`ɖ߂
		MOVE.L	REF_TRSTWORK(A6),A0
		MOVE.L	A0,DRIVER_JMPTBL+16(A6)
		JSR	(A0)
		MOVEM.L	D0/D7/A0-A1,-(SP)
		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#32-1,D7
		MOVEQ.L	#$FF,D0
refresh_sub2:
		MOVE.B	D0,T_STCHANGE(A0)
		MOVE.B	D0,T_KEYONCHANGE(A0)
		MOVE.B	D0,T_KEYCHANGE(A0)
		MOVE.B	D0,T_VELCHANGE(A0)
		LEA.L	TRST(A0),A0
		DBRA.W	D7,refresh_sub2
		MOVE.L	D0,TRACK_CHANGE(A6)

		MOVEM.L	(SP)+,D0/d7/a0-a1
		RTS



*==================================================
* DRIVER L[I
*	SẴgbNL[nee
*==================================================

clear_keyon::
	*DRIVER_TRKSTATkeyoff_subĂ
		MOVEM.L	A0-A1,-(SP)
		LEA.L	DRIVER_JMPTBL+16(A6),A1
		MOVE.L	(A1),CLR_KEYONWORK(A6)
		LEA.L	keyoff_sub(PC),A0
		MOVE.L	A0,(A1)
		MOVEM.L	(SP)+,A0-A1
		RTS

keyoff_sub:
		MOVEM.L	D7/A0,-(SP)
		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#32-1,D7
keyoff_sub10:
		CLR.B	T_STCHANGE(A0)
		ST.B	T_KEYONCHANGE(A0)
		ST.B	T_KEYONSTAT(A0)
		CLR.B	T_KEYCHANGE(A0)
		CLR.B	T_VELCHANGE(A0)
		LEA.L	TRST(A0),A0
		DBRA.W	D7,keyoff_sub10

		MOVEQ.L	#$FF,D7
		MOVE.L	D7,TRACK_CHANGE(A6)
		CLR.L	TRACK_ENABLE(A6)

	*{Ƃ̃[`ɖ߂
		MOVE.L	CLR_KEYONWORK(A6),DRIVER_JMPTBL+16(A6)

		MOVEM.L	(SP)+,D7/A0
		RTS


*==================================================
*gbN}XN
*==================================================

*PgbN}XN]
*	d1.w <- gbNԍ

trmask_chg::
		MOVEM.L	D0-D1,-(SP)
		DRIVER	DRIVER_GETMASK
		BCHG.L	D1,D0
		MOVE.L	D0,D1
		DRIVER	DRIVER_SETMASK
		MOVEM.L	(SP)+,D0-D1
		RTS

*SgbNnm

all_track_on::
		MOVE.L	D1,-(SP)
		MOVEQ.L	#$FF,D1
		DRIVER	DRIVER_SETMASK
		MOVE.L	(SP)+,D1
		RTS

*SgbNnee

all_track_off::
		MOVE.L	D1,-(SP)
		MOVEQ.L	#0,D1
		DRIVER	DRIVER_SETMASK
		MOVE.L	(SP)+,D1
		RTS

*SgbN]

all_track_reverse::
		MOVEM.L	D0-D1,-(SP)
		DRIVER	DRIVER_GETMASK
		NOT.L	D0
		MOVE.L	D0,D1
		DRIVER	DRIVER_SETMASK
		MOVEM.L	(SP)+,D0-D1
		RTS


*
*
* ADDITIONAL PARTS
*
*

PCMDTBLCNT:	EQU	(PCMDRV_TBLEND-PCMDRV_TABLE)/(2*5)

*
* SEARCH ADPCM DRIVER	97-04-01, 97-04-13
*
SEARCH_PCMDRV::
		MOVEM.L	D0-D4/A0-A1,-(SP)
*
		LEA.L	PCMDRV_TABLE(PC),A0
		MOVEQ.L	#PCMDTBLCNT-1,D0
* SEARCH LOOP
SEARCH_PCMDRV2:
		MOVEQ.L	#$00,D3
		SUBA.L	A1,A1
		MOVEM.W	(A0),D1-D4/A1
		SWAP.W	D3			* D3.L : STRING
		MOVE.W	D4,D3
		LEA.L	2*5(A0),A0
		MOVEA.L	(A1),A1
		ADDA.W	D2,A1
		CMP.L	(A1),D3
		DBEQ.W	D0,SEARCH_PCMDRV2
		BEQ	SEARCH_PCMDRV3
* NOT MATCH = INTERNAL
		MOVEQ.L	#$00,D1
SEARCH_PCMDRV3:
		MOVE.B	D1,PCMDRV_TYPE(A6)
		MOVEM.L	(SP)+,D0-D4/A0-A1
		RTS

PCMDRV_TABLE:
*			 +-------------------- i[R[h
*			 |   +---------------- xN^̃ItZbg
*			 |   |      +--------- r
*			 |   |      |      +-- xN^
*			 |   |      |      |
*			CDE,OFS, STRINGS ,VCT
		.DC.W	004,-16,'PC','M8',$88		* PCM8A
		.DC.W	001,-08,'MP','CM',$84		* MPCM
		.DC.W	002,-14,'M8','++',$88		* PCM8++
		.DC.W	003,-16,'Mi','aP',$88		* MiaPie
		.DC.W	005,-16,'RD','N_',$88		* rdn
		.DC.W	006,-08,'PC','M8',$88		* PCM8
PCMDRV_TBLEND:



		.END
