*
*	multi music status display MMDSP v0.29 Rel.10
*
*			program parts of 'MCDRV'
*

		.include	doscall.mac
		.include	mccall.mac
		.include	mmdsp.equ


* Global Symbol ------------------------------- *

		.xref	VOL_DEFAULT
		.xref	EXEC_EXTERNAL
		.xref	mpf_setup


* Text Section -------------------------------- *

		.cpu	68000
		.text


*
*@MCDRV JOB TABLE
*
MCDRV_ENTRY::
		.DC.W	MCDRV_CHECK-MCDRV_ENTRY
		.DC.W	MCDRV_NAME-MCDRV_ENTRY
		.DC.W	MCDRV_INIT-MCDRV_ENTRY
		.DC.W	MCDRV_SYSSTAT-MCDRV_ENTRY
		.DC.W	MCDRV_TRKSTAT-MCDRV_ENTRY
		.DC.W	MCDRV_GETMASK-MCDRV_ENTRY
		.DC.W	MCDRV_SETMASK-MCDRV_ENTRY
		.DC.W	MCDRV_FILEEXT-MCDRV_ENTRY
		.DC.W	MCDRV_FLOADP-MCDRV_ENTRY
		.DC.W	MCDRV_PLAY-MCDRV_ENTRY
		.DC.W	MCDRV_PAUSE-MCDRV_ENTRY
		.DC.W	MCDRV_CONT-MCDRV_ENTRY
		.DC.W	MCDRV_STOP-MCDRV_ENTRY
		.DC.W	MCDRV_FADEOUT-MCDRV_ENTRY
		.DC.W	MCDRV_SKIP-MCDRV_ENTRY
		.DC.W	MCDRV_SLOW-MCDRV_ENTRY

*
* KEEP CHECK
*
MCDRV_CHECK:
		MOVE.L	A0,-(SP)
		MOVEA.L	$90.W,A0
		CMPI.L	#'-MCD',-12(A0)
		BNE	MCDRV_CHECK2
		CMPI.L	#'RV0-',-8(A0)
		BNE	MCDRV_CHECK2
		MOVE.L	-4(A0),D0
		CMPI.L	#$130000,D0
		BCC	MCDRV_CHECK3
MCDRV_CHECK2:
		MOVEQ.L	#$FF,D0
MCDRV_CHECK3:
		MOVE.L	(SP)+,A0
		RTS

*
* GET DRIVER NAME
*
MCDRV_NAME:
		PEA.L	MCDRV_NAMESTR(PC)		* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

MCDRV_NAMESTR:
		.DC.B	'MCDRV',0
		.EVEN

*
* INITIALIZE
*
MCDRV_INIT:
		MOVEM.L	D0/A0-A1,-(SP)
		MCCALL	_GETKEYONPTR
		MOVEA.L	D0,A0
		MOVE.L	A0,DRV_WORK+4(A6)	* L[Iւ̃AhX
		MOVE.W	(A0),D0
		MOVE.W	D0,DRV_WORK+8(A6)	* FIFO ̊Ǘ|C^
		MCCALL	_GETWORKADR
		MOVE.L	D0,DRV_WORK(A6)		* MCDRV ̃[NGAAhX
		MOVEA.L	D0,A0
		CLR.L	TRACK_ENABLE(A6)
		MOVE.W	#202,CYCLETIM(A6)
		MOVE.W	#77,TITLELEN(A6)

		LEA.L	TRACK_STATUS(A6),A0
		MOVEQ.L	#1,D0
MCDRV_INIT2:
		MOVE.B	D0,T_TRACKNO(A0)
		LEA.L	$20(A0),A0
		ADDQ.W	#1,D0
		CMPI.W	#32,D0
		BLS	MCDRV_INIT2
		CLR.B	SORCERIAN_FLAG(A6)
		MOVEM.L	(SP)+,D0/A0-A1
		RTS

*
* GET SYSTEM STATUS
*
MCDRV_SYSSTAT:
		MOVEM.L	D0/A0,-(SP)
		MCCALL	_GETTITLE
		MOVE.L	D0,SYS_TITLE(A6)	* ^Cg̃AhX
		MCCALL	_GETLOOPCOUNT
		MOVE.W	D0,SYS_LOOP(A6)		* loop count
		MCCALL	_GETTEMPO
		MOVE.W	D0,SYS_TEMPO(A6)	* timer-b
		MOVEA.L	DRV_WORK(A6),A0
		MOVE.W	-$80(A0),D1
		SEQ.B	D0
		EXT.W	D0
		MOVE.W	D0,PLAYEND_FLAG(A6)
		CMPI.B	#$02,D1
		SEQ.B	D0
		EXT.W	D0
		MOVE.W	D0,PLAY_FLAG(A6)
		MOVEM.L	(SP)+,D0/A0
		RTS
*L0098ae:
*		.DC.W	0

*
* GET TRACK STATUS
*
MCDRV_TRKSTAT:
		BSR	L0098b8
		BSR	L0099a8
		RTS

L0098b8:
		MOVEM.L	D0-D3/D5/D7/A0-A3,-(SP)
		MOVEA.L	DRV_WORK(A6),A0
		LEA.L	TRACK_STATUS(A6),A1
		LEA.L	VOL_DEFAULT(PC),A2
*	MOVEA.L	DRV_WORK(A6),a3
		MOVEA.L	A0,A3
		MCCALL	_GETPLAYFLG
		MOVE.L	D0,D2
		MOVEQ.L	#0,D1
		MOVEQ.L	#32-1,D7
@@:
		BSR	L0098fa
		LEA.L	$100(A0),A0
		LEA.L	$20(A1),A1
		ADDQ.W	#1,D1
		DBRA.W	D7,@B

		MOVE.L	TRACK_ENABLE(A6),D0
		MOVE.L	D2,TRACK_ENABLE(A6)
		EOR.L	D2,D0
		MOVE.L	D0,TRACK_CHANGE(A6)
		MOVEM.L	(SP)+,D0-D3/D5/D7/A0-A3
		RTS

L0098fa:
		MOVEQ.L	#0,D5
		MOVE.L	D5,(A1)
		MOVE.W	2(A0),D3
		TST.B	D3
		BPL	L009914
		MOVEQ.L	#0,D0
		CMPI.B	#$8F,D3
		BHI	L009926
		MOVEQ.L	#3,D0
		BRA	L009926
L009914:
		moveq.l	#1,d0
		cmpi.b	#$f,d3
		bls	L009926
		moveq.l	#2,d0
		cmpi.b	#$1f,d3
		bls	L009926
		moveq.l	#0,d0
L009926:
		cmp.b	4(a1),d0
		beq	L00993a
		move.b	d0,4(a1)
		bset.l	#0,d5
		moveq.l	#0,d0
		move.w	d0,6(a1)
L00993a:
		cmp.b	#3,d0
		BNE	L009968
		move.w	$12(a0),d0
		cmp.w	8(a1),d0
		beq	L009952
		move.w	d0,8(a1)
		bset.l	#1,d5
L009952:
		moveq.l	#$7f,d0
		and.b	$23(a0),d0
		cmp.w	$a(a1),d0
		beq	L00998e
		move.w	d0,$a(a1)
		bset.l	#2,d5
		bra	L00998e
L009968:
		move.w	$12(a0),d0
		cmp.w	8(a1),d0
		beq	L00997a
		move.w	d0,8(a1)
		bset.l	#1,d5
L00997a:
		moveq.l	#$7f,d0
		and.b	$23(a0),d0
		cmp.w	$a(a1),d0
		beq	L00998e
		move.w	d0,$a(a1)
		bset.l	#2,d5
L00998e:
		moveq.l	#0,d0
		move.b	$21(a0),d0
		cmp.w	$c(a1),d0
		beq	L0099a2
		move.w	d0,$c(a1)
		bset.l	#3,d5
L0099a2:
		move.b	d5,(a1)
		RTS

L0099a8:
		movem.l	d0-d4/a0-a4,-(SP)
		lea.l	TRACK_STATUS(A6),a2
		MOVEA.L	a2,a0
		MOVEA.L	DRV_WORK+4(A6),a1
		move.w	DRV_WORK+8(A6),d7
		bra	L009a46
L0099be:
		lea.l	2(a1,d7.w),a0
		moveq.l	#0,d0
		move.b	(a0)+,d0
		cmpi.w	#$20,d0			;' '
		bcc	L009a40
		mulu.w	#$20,d0
		lea.l	0(a2,d0.w),a4
		lea.l	$10(a4),a3
		move.b	(a0)+,d2
		move.b	(a0)+,d3
		BNE	L0099f6
		moveq.l	#7,d0
L0099e0:
		cmp.b	(a3)+,d2
		dbeq	d0,L0099e0
		BNE	L009a40
		subq.w	#7,d0
		neg.w	d0
		bset.b	d0,1(a4)
		bset.b	d0,$e(a4)
		bra	L009a40
L0099f6:
		moveq.l	#7,d0
L0099f8:
		cmp.b	(a3)+,d2
		dbeq	d0,L0099f8
		BNE	L009a0c
		subq.w	#7,d0
		neg.w	d0
		bset.b	d0,1(a4)
		bset.b	d0,$e(a4)
L009a0c:
		move.b	$e(a4),d0
		moveq.l	#7,d4
L009a12:
		lsr.b	#1,d0
		dbcs	d4,L009a12
		bcc	L009a20
		moveq.l	#7,d0
		sub.w	d4,d0
		bra	L009a22
L009a20:
		moveq.l	#0,d0
L009a22:
		bset.b	d0,1(a4)
		bclr.b	d0,$e(a4)
		bset.b	d0,3(a4)
		move.b	d2,$10(a4,d0.w)
		cmp.b	$18(a4,d0.w),d3
		beq	L009a40
		bset.b	d0,2(a4)
		move.b	d3,$18(a4,d0.w)
L009a40:
		addq.w	#4,d7
		andi.w	#$3ff,d7
L009a46:
		cmp.w	(a1),d7
		BNE	L0099be
		move.w	d7,DRV_WORK+8(A6)
		movem.l	(SP)+,d0-d4/a0-a4
		RTS

*
* GET TRACK MASK
*
MCDRV_GETMASK:
		MOVE.L	D1,-(SP)
		MCCALL	_GETPLAYFLG
		MOVE.L	(SP)+,D1
*		RTS

*
* SET TRACK MASK
*
MCDRV_SETMASK:
		RTS

*
* GET FILE-EXT TABLE
*
MCDRV_FILEEXT:
		PEA.L	FILEEXT_DAT(PC)			* 97-07-07
		MOVE.L	(SP)+,D0
		RTS

FILEEXT_DAT:
		.DC.B	_MDX,'MDX'
		.DC.B	_MDR,'MDR'
		.DC.B	_RCP,'RCP'
		.DC.B	_MID,'MID'
		.DC.B	_STD,'STD'
		.DC.B	_MFF,'MFF'
		.DC.B	_SMF,'SMF'
		.DC.B	_ZDF,'ZDF'
		.DC.B	_MDF,'MDF'
		.DC.B	_MDC,'MDC'
		.DC.B	_MPF,'MPF'

* ADDITIONAL 97-06-28
		.DC.B	_MDZ,'MDZ'
		.DC.B	_ZMS,'ZMS'
		.DC.B	0
		.EVEN

*
* CHECK & EXEC FILE-EXT.
*
MCDRV_FLOADP:
		MOVE.L	A1,-(SP)
		CMPI.B	#_MDX,D0
		BEQ	MCDRV_FLOADP1
		CMPI.B	#_MDR,D0
		BEQ	MCDRV_FLOADP1
		CMPI.B	#_RCP,D0
		BEQ	MCDRV_FLOADP2
		CMPI.B	#_MID,D0
		BEQ	MCDRV_FLOADP3
		CMPI.B	#_STD,D0
		BEQ	MCDRV_FLOADP3
		CMPI.B	#_MFF,D0
		BEQ	MCDRV_FLOADP3
		CMPI.B	#_SMF,D0
		BEQ	MCDRV_FLOADP3
		CMPI.B	#_ZDF,D0
		BEQ	MCDRV_FLOADP6
		CMPI.B	#_MDF,D0
		BEQ	MCDRV_FLOADP6
		CMPI.B	#_MDC,D0
		BEQ	MCDRV_FLOADP6
		CMPI.B	#_MPF,D0
		BEQ	MCDRV_FLOADP7

* ADDITIONAL 97-06-28
		CMPI.B	#_MDZ,D0
		BEQ	MCDRV_FLOADP4
		CMPI.B	#_ZMS,D0
		BEQ	MCDRV_FLOADP5
		MOVE.L	(SP)+,A1
		MOVEQ.L	#$FF,D0
		RTS

MCDRV_FLOADP1:
		LEA.L	FNAME1(PC),A0
		BRA	@F
MCDRV_FLOADP2:
		LEA.L	FNAME2(PC),A0
		BRA	@F
MCDRV_FLOADP3:
		LEA.L	FNAME3(PC),A0
		BRA	@F
MCDRV_FLOADP4:
		LEA.L	FNAME4(PC),A0
		BRA	@F
MCDRV_FLOADP5:
		LEA.L	FNAME5(PC),A0
		BRA	@F
MCDRV_FLOADP6:
		LEA.L	FNAME6(PC),A0
@@:		BSR	EXEC_EXTERNAL
		BRA	MCDRV_FLOADP_E

MCDRV_FLOADP7:
		BSR	mpf_setup
		MOVEQ.L	#$00,D0
MCDRV_FLOADP_E:
		MOVE.L	(SP)+,A1
		RTS

FNAME1:		.DC.B	'mdx2mdc',0
FNAME2:		.DC.B	'rcp2mdc',0
FNAME3:		.DC.B	'smf2mdc',0
FNAME4:		.DC.B	'mdz2mdc',0
FNAME5:		.DC.B	'zms2mdc',0
FNAME6:		.DC.B	'mmcp',0
		.EVEN

*
* PLAY
*
MCDRV_PLAY:
		MCCALL	_STOPMUSIC
		MCCALL	_PLAYMUSIC
		RTS

*
* PAUSE / CONT
*
MCDRV_PAUSE:
MCDRV_CONT:
		MCCALL	_PAUSEMUSIC
		RTS

*
* STOP
*
MCDRV_STOP:
		MCCALL	_STOPMUSIC
		RTS

*
* FADEOUT
*
MCDRV_FADEOUT:
		MOVE.L	D1,-(SP)
		MOVE.W	MMDSP_FADE_SPD(A6),D1
		MCCALL	_FADEOUT
		MOVE.L	(SP)+,D1
		RTS

*
* SKIP
*
MCDRV_SKIP:
		MOVE.L	D1,-(SP)
		MOVEQ.L	#12,D1
		MCCALL	_SKIPPLAY
		MOVE.L	(SP)+,D1
*		RTS

*
* SLOW
*
MCDRV_SLOW:
		RTS



		.END
