*
*	multi music status display MMDSP v0.29 Rel.10
*
*			program parts of 'SUB ROUTINES'
*

		.include	doscall.mac
		.include	iocscall.mac
		.include	mmdsp.equ


* Global Symbol ------------------------------- *

		.xref	read_1k_bytes
		.xref	text_palet
		.xref	HSCOPY
		.xref	PUT_PALETINFO


* Text Section -------------------------------- *

		.cpu	68000
		.text


L006c44:
ARGV	=	4+(4*5)
		MOVEM.L	A0-A4,-(SP)
		MOVEM.L	ARGV(SP),A1-A2
		LINK	A5,#-512
		MOVE.W	#0,-(SP)
		PEA.L	(A1)
		DOS	_OPEN
		ADDQ.L	#6,SP
		TST.L	D0
		BPL	L006cf2
		MOVE.L	A2,D0
		BEQ	L006cf0
L006c66:
		LEA.L	L006cfa(PC),A3
		PEA.L	-512(A5)
		PEA.L	0.W
		PEA.L	(A2)
		DOS	_GETENV
		LEA.L	12(SP),SP
		TST.L	D0
		BMI	L006ce6
		LEA.L	-512(A5),A4
L006c80:
		TST.B	(A4)
		BEQ	L006ce6
		LEA.L	-256(A5),A3
L006c88:
		MOVE.B	(A4),D0
		BEQ	L006cb0
		ADDQ.L	#1,A4
		CMPI.B	#',',D0
		BEQ	L006cb0
		CMPI.B	#';',D0
		BEQ	L006cb0
		CMPI.B	#'|',D0
		BEQ	L006cb0
		CMPI.B	#' ',D0
		BEQ	L006cb0
		CMPI.B	#9,D0
		BEQ	L006cb0
		MOVE.B	D0,(A3)+
		BRA	L006c88
L006cb0:
		MOVE.B	-1(A4),D0
		CMPI.B	#':',D0
		BEQ	L006cc4
		CMPI.B	#'\',D0
		BEQ	L006cc4
		MOVE.B	#'\',(A3)+
L006cc4:
		MOVEA.L	A1,A0
L006cc6:
		MOVE.B	(A0)+,(A3)+
		BNE	L006cc6
*		pea.l	-$100(a6)
*		bsr	L006d0c
*		addq.l	#4,sp
*L006d0c:
		LEA.L	-256(A5),A0
		MOVEQ.L	#0,D0
		CMPI.B	#':',1(A0)
		BNE	L006d24
		MOVE.B	(A0),D0
		ANDI.B	#$DF,D0
		SUBI.B	#$40,D0
L006d24:
		MOVE.W	D0,-(SP)
		DOS	_DRVCTRL
		ADDQ.L	#2,SP
		BTST.L	#2,D0
		SNE.B	D0
		EXT.W	D0
		TST.W	D0
		BMI	L006c80
		MOVE.W	#0,-(SP)
		PEA.L	-256(A5)
		DOS	_OPEN
		ADDQ.L	#6,SP
		TST.L	D0
		BMI	L006c80
		BRA	L006cf2

L006ce6:
		TST.B	(A2)+
		BNE	L006ce6
		TST.B	(A2)
		BNE	L006c66
L006cf0:
		MOVEQ.L	#$FF,D0
L006cf2:
		UNLK	A5
		MOVEM.L	(SP)+,A0-A4
		RTS
L006cfa:
		.dc.b	$00,$00

*
* CLOSE
*
* IN	D0.W : FILE HANDLE
*
CLOSE:
		MOVE.W	4(SP),D0
		EXT.L	D0
		BMI	CLOSE2
		MOVE.W	D0,-(SP)
		DOS	_CLOSE
		ADDQ.L	#2,SP
CLOSE2:
		RTS

*L006d0c:
*ARGV	=	4
*		MOVEA.L	ARGV(SP),A0
*		MOVEQ.L	#0,D0
*		CMPI.B	#':',1(A0)
*		BNE	L006d24
*		MOVE.B	(A0),D0
*		ANDI.B	#$DF,D0
*		SUBI.B	#$40,D0
*L006d24:
*		MOVE.W	D0,-(SP)
*		DOS	_DRVCTRL
*		ADDQ.L	#2,SP
*		BTST.L	#2,D0
*		SNE.B	D0
*		EXT.W	D0
*		EXT.L	D0
*		RTS

*
* SEEK
*
* IN	D0.W : FILE HANDLE
* OUT	D0.L : FILE SIZE
*
SEEK:
ARGV	=	4+(4*2)
		MOVEM.L	D1-D2,-(SP)
		MOVE.W	ARGV(SP),D0
		LINK	A5,#0
		MOVE.W	#1,-(SP)
		PEA.L	0.W
		MOVE.W	D0,-(SP)
		DOS	_SEEK
		MOVE.L	D0,D1
		BMI	SEEK2
		MOVE.W	#2,6(SP)
		DOS	_SEEK
		MOVE.L	D0,D2
		BMI	SEEK2
		CLR.W	6(SP)
		MOVE.L	D1,2(SP)
		DOS	_SEEK
		TST.L	D0
		BMI	SEEK2
		MOVE.L	D2,D0
SEEK2:
		UNLK	A5
		MOVEM.L	(SP)+,D1-D2
		RTS


L006d74::
ARGV	=	4+(4*6)
		MOVEM.L	D1-D3/A1-A3,-(SP)
		MOVEM.L	ARGV(SP),A1-A3		* A1.L : t@C
						* A2.L : ϐ(0ȂT[`Ȃ)
						* A3.L : obt@̐擪ɂwb_̑傫
		LINK	A5,#0
		MOVEQ.L	#$FF,D2
		MOVE.L	D2,D3
		PEA.L	(A2)
		PEA.L	(A1)
		BSR	L006c44			* OPEN
		MOVE.L	D0,D1			* D1.W : FILE HANDLE
		BMI	L006dbc
		MOVE.W	D1,-(SP)
		BSR	SEEK			* SEEK
		MOVE.L	D0,D2			* D2.L : FILE SIZE
		BMI	L006dbc
		PEA.L	(A3,D2.L)
		DOS	_MALLOC
		MOVE.L	D0,D3
		BMI	L006db4
		MOVE.L	D2,-(SP)
		PEA.L	(A3,D3.L)
		MOVE.W	D1,-(SP)
		DOS	_READ
		CMP.L	D2,D0
		BLT	L006dbc
		BRA	L006dbe
L006db4:
		MOVE.L	D3,-(SP)
		BSR	MFREE
		MOVEQ.L	#$FE,D2
		BRA	L006dbe
L006dbc:
		MOVEQ.L	#$FF,D2
L006dbe:
		MOVE.W	D1,-(SP)
		BSR	CLOSE
		MOVE.L	D2,D0
		MOVEA.L	D3,A0
		UNLK	A5
		MOVEM.L	(SP)+,D1-D3/A1-A3
		RTS

*
* OPEN & SEEK
*
* OUT	D0.L : FILE SIZE
*	D1.L : FILE HANDLE
*
OPEN_SEEK::
ARGV	=	4+(4*5)
		MOVEM.L	D2-D3/A1-A3,-(SP)
		MOVEM.L	ARGV(SP),A1-A2
		LINK	A5,#0
		MOVEQ.L	#$FF,D2
		MOVEQ.L	#$FF,D3
		MOVE.L	A2,-(SP)
		MOVE.L	A1,-(SP)
		BSR	L006c44			* OPEN
		MOVE.L	D0,D1
		BMI	L006dbc2
		MOVE.W	D1,-(SP)
		BSR	SEEK
		MOVE.L	D0,D2
		BPL	L006dbe2
L006dbc2:
		MOVEQ.L	#$FF,D2
L006dbe2:
		MOVE.L	D2,D0
		UNLK	A5
		MOVEM.L	(SP)+,D2-D3/A1-A3
		RTS

*
* SUFFIX EXTENTION
*
* IN	A0.L : FILENAME
*	A1.L : EXTENTION
* OUT	A0.L : FILENAME + EXTENTION
*
L006dd0::
ARGV	=	4+(4*2)
		MOVEM.L	A0-A1,-(SP)
		MOVEM.L	ARGV(SP),A0-A1
		LINK	A5,#-92
		PEA.L	-92(A5)
		PEA.L	(A0)
		DOS	_NAMECK
		TST.L	D0
		BMI	SUFEXT4
		TST.B	-6(A5)
		BNE	SUFEXT4
SUFEXT2:
		TST.B	(A0)+
		BNE	SUFEXT2
		SUBQ.L	#1,A0
SUFEXT3:
		MOVE.B	(A1)+,(A0)+
		BNE	SUFEXT3
SUFEXT4:
		UNLK	A5
		MOVEM.L	(SP)+,A0-A1
		RTS

*	-	-	-	-	-	-	-	-	*
*	r							*
*	-	-	-	-	-	-	-	-	*
L006e02::
ARGV	=	4+(4*4)
		MOVEM.L	D1-D2/A0-A1,-(SP)
		MOVEM.L	ARGV(SP),A0-A1
		MOVEQ.L	#0,D0
		MOVEQ.L	#$DF,D2
L006e0e:
		MOVE.B	(A0)+,D0
		BEQ	L006e22
		AND.B	D2,D0
		MOVE.B	(A1)+,D1
		AND.B	D2,D1
		SUB.B	D1,D0
		BEQ	L006e0e
		BRA	L006e24
L006e22:
		MOVE.B	(A1),D0
L006e24:
		MOVEM.L	(SP)+,D1-D2/A0-A1
		RTS

*
* MFREE
*
MFREE::
		MOVE.L	4(SP),D0
		BEQ	MFREE2				* 97-10-29
		BMI	MFREE2
		MOVE.L	D0,-(SP)
		DOS	_MFREE
		ADDQ.L	#4,SP
MFREE2:
		RTS

*	-	-	-	-	-	-	-	-	*
*	ZDF WJ							*
*	-	-	-	-	-	-	-	-	*
L006e38::
		movem.l	d1/a0-a2,-(sp)
		movem.l	$14(sp),a0-a1
		link	a5,#0
		moveq.l	#$ff,d1
		cmpi.l	#'ZDF0',(a0)
		bne	L006e72
		cmpi.w	#$d0a,4(a0)
		bne	L006e72
		bsr	lzz_search_and_load
		move.l	d0,d1
		bmi	L006e72
		pea.l	(a1)
		pea.l	(a0)
		movea.l	d1,a2
		jsr	12(a2)
		addq.l	#8,sp
		tst.l	d0
		bmi	L006e78
		move.l	d1,d0
		bra	L006e78

L006e72:
		move.l	d1,-(sp)
		bsr	MFREE
		moveq.l	#$ff,d0
L006e78:
		unlk	a5
		movem.l	(sp)+,d1/a0-a2
		rts

*	-	-	-	-	-	-	-	-	*
*	Lzz ǂݍ݁^WJ						*
*	-	-	-	-	-	-	-	-	*
L006e80::
		movem.l	d1/a0-a3,-(sp)
		movem.l	$18(sp),a0-a3
		link	a5,#0
		pea.l	0(a2,a3.l)
		DOS	_MALLOC
		move.l	d0,d1
		bmi	L006eac
		pea.l	0(a3,d1.l)
		pea.l	(a1)
		jsr	$10(a0)
		addq.l	#8,sp
		tst.l	d0
		bmi	L006eb4
		move.l	d1,d0
		bra	L006eb4
L006eac:
		move.l	d1,-(sp)
		bsr	MFREE
		moveq.l	#$ff,d0
L006eb4:
		unlk	a5
		movem.l	(sp)+,d1/a0-a3
		rts

*	-	-	-	-	-	-	-	-	*
*	Lzz [h							*
*	-	-	-	-	-	-	-	-	*
lzz_search_and_load:
		MOVEM.L	D1-D2/A0-A1,-(SP)
		LINK	A5,#-512
*
		LEA.L	-512(A5),A0			* 'LZZPATH' WJ
		MOVE.L	A0,-(SP)
		PEA.L	0.W
		PEA.L	env_lzzpath(PC)
		DOS	_GETENV
		TST.L	D0
		BMI	lzz_search_and_load3		* ϐȂ

lzz_search_and_load1:
		TST.B	(A0)+				* pX̕I[Ɉړ
		BNE	lzz_search_and_load1
		SUBQ.L	#1,A0
		CMPI.B	#'\',-1(A0)			* '\' Ȃꍇt
		BEQ	lzz_search_and_load2
		CMPI.B	#'/',-1(A0)
		BEQ	lzz_search_and_load2
		MOVE.B	#'\',(A0)+
lzz_search_and_load2:
.ifdef SEARCH_LZZ_RX
		LEA.L	fname_lzz_r(PC),A1
		BSR	load_lzz_from_LZZPATH
		BPL	check_lzz_lzxed
		LEA.L	fname_lzz_x(PC),A1
		BSR	load_lzz_from_LZZPATH
		BPL	check_lzz_lzxed
.endif
		LEA.L	fname_lzz(PC),A1
		BSR	load_lzz_from_LZZPATH
		BPL	check_lzz_lzxed
lzz_search_and_load3:
.ifdef SEARCH_LZZ_RX
		LEA.L	fname_lzz_r(PC),A0
		BSR	search_lzmz_from_path
		BPL	lzz_search_and_load4
		LEA.L	fname_lzz_x(PC),A0
		BSR	search_lzmz_from_path
		BPL	lzz_search_and_load4
.endif
		LEA.L	fname_lzz(PC),A0
		BSR	search_lzmz_from_path
.ifdef USE_LZM
		BPL	lzz_search_and_load4
		LEA.L	fname_lzm(PC),A0
		BSR	search_lzmz_from_path
.endif
		BMI	lzz_search_and_load7
lzz_search_and_load4:
		BSR	get_lzz_memory_block
		BMI	lzz_search_and_load_err
check_lzz_lzxed:
		CMPI.L	#'LZX ',4(A0)
		BNE	lzz_search_and_load6
check_lzz_lzxed2:
		BSR	extract_lzxed_lzz
		TST.L	D0
		BMI	lzz_search_and_load_err
lzz_search_and_load6:
		CMPI.L	#'LzzR',8(A0)
		BNE	lzz_search_and_load_err
		MOVE.L	4(A0),-(SP)
		PEA.L	(A0)
		DOS	_SETBLOCK
		MOVE.L	D2,D0
		BRA	lzz_search_and_load7
lzz_search_and_load_err:
		MOVE.L	D2,-(SP)
		BSR	MFREE
		MOVEQ.L	#$FF,D0
lzz_search_and_load7:
		UNLK	A5
		MOVEM.L	(SP)+,D1-D2/A0-A1
		RTS

*	-	-	-	-	-	-	-	-	*
*	w肵 Lzz  'LZZPATH' 烍[hĂ݂			*
*	-	-	-	-	-	-	-	-	*
load_lzz_from_LZZPATH:
		move.l	a0,-(sp)			* pX

load_lzz_from_LZZPATH1:
		move.b	(a1)+,(a0)+			* 'pzth'+'lzz?' 
		bne	load_lzz_from_LZZPATH1

		bsr	get_lzz_memory_block		* [hĂ݂
		bpl	load_lzz_from_LZZPATH2		* ok.
		tst.l	d2
		bmi	load_lzz_from_LZZPATH11		* Ȃėꍇ

		move.l	a0,-(sp)			* ĂׂȂꍇ͐؂
		DOS	_MFREE
		addq.l	#4,sp

load_lzz_from_LZZPATH11:
		moveq.l	#$ff,d0
		move.l	(sp)+,a0
		rts

load_lzz_from_LZZPATH2:					* [hłꍇ
		cmpi.w	#'HU',(a0)			* for 'execd-Lzz'
		bne	load_lzz_from_LZZPATH3
		lea.l	$40(a0),a0			* t@C擪+64
*		subi.l	#$40,d0				* TCY-64
load_lzz_from_LZZPATH3:
		addq.l	#4,sp				* pXj
		rts

*	-	-	-	-	-	-	-	-	*
*	Lzz^Lzm p擾, w肵 LZZ [h			*
*	-	-	-	-	-	-	-	-	*
get_lzz_memory_block:
		PEA.L	$FFFF.W
		DOS	_MALLOC
		ANDI.L	#$00FFFFFF,D0
		MOVE.L	D0,D1
		MOVE.L	D0,(SP)
		DOS	_MALLOC
		ADDQ.L	#4,SP
		MOVE.L	D0,D2
		BMI	@F				* s

		MOVEA.L	D2,A0				* w肵 Lzz [hĂ݂
		ADD.L	D2,D1
		MOVE.L	D1,-(SP)
		MOVE.L	D2,-(SP)
		PEA.L	-512(A5)
		MOVE.B	#1,(SP)
		MOVE.W	#3,-(SP)
		DOS	_EXEC
		LEA.L	14(SP),SP
		TST.L	D0
		RTS

@@:		MOVEQ.L	#$FF,D0
		RTS

*	-	-	-	-	-	-	-	-	*
*	Lzz^Lzm pXT						*
*	-	-	-	-	-	-	-	-	*
search_lzmz_from_path:
		MOVEM.L	A0-A1,-(SP)
		LEA.L	-512(A5),A1
@@:		MOVE.B	(A0)+,(A1)+
		BNE	@B

		PEA.L	0.W
		PEA.L	-256(A5)
		PEA.L	-512(A5)
		MOVE.W	#2,-(SP)
		DOS	_EXEC
		LEA.L	14(SP),SP
		TST.L	D0
		MOVEM.L	(SP)+,A0-A1
		RTS

*	-	-	-	-	-	-	-	-	*
*	LZX ňkꂽ Lzz^Lzm WJ				*
*	-	-	-	-	-	-	-	-	*
extract_lzxed_lzz:
		movem.l	d6/a0-a5,-(sp)
		movea.l	a0,a4
		movea.l	a4,a5
		lea.l	0(a0,d0.l),a1
		move.l	d1,d6
		move.l	a4,d1
		move.l	$12(a0),d0
		addi.l	#$2800,d0
		cmp.l	d1,d0
		bcc	L00726e
		move.l	d6,4(a4)
		move.l	a5,8(a4)
		lea.l	L007266(pc),a4
		jmp	2(a5)
L007266:
		moveq.l	#0,d0
		movem.l	(sp)+,d6/a0-a5
		rts
L00726e:
		moveq.l	#$ff,d0
		movem.l	(sp)+,d6/a0-a5
		rts





L006f54::
		movem.l	d1-d7/a0-a6,-(sp)
		link	a5,#-798
		move.l	a2,-$31e(a5)
		move.l	d2,-$31a(a5)
		move.l	a1,-$306(a5)
		move.l	a1,-$30e(a5)
		move.l	d1,-$30a(a5)
		clr.w	-$314(a5)
		clr.l	-$312(a5)
		move.w	#$ffff,-$302(a5)
L006f7e:
		bsr	L00704a
		tst.l	d0
		bmi	L0072b0
		bsr	L00707c
		cmpi.b	#$23,(a0)+		;'#'
		bne	L006f7e
		bsr	L00707c
		bsr	L00708e
		move.w	d0,d1
		mulu.w	#$300,d1
		beq	L0072b4
		sub.l	d1,-$30a(a5)
		bcs	L0072b4
		add.l	d1,-$30e(a5)
		move.w	d0,-$316(a5)
		movea.l	-$306(a5),a0
		lsr.l	#6,d1
		subq.l	#1,d1
		move.l	d0,-(sp)
		moveq.l	#0,d0
L006fbc:
		.rept	16
		move.l	d0,(a0)+
		.endm
		subq.l	#1,d1
		bcc	L006fbc
		move.l	(sp)+,d0
L006fe0:
		bsr	L00704a
		tst.l	d0
		bmi	L0072d4
		bsr	L00707c
		move.b	(a0),d0
		beq	L006fe0
		cmp.b	#$2b,d0			;'+'
		beq	L0070ba
		cmp.b	#$40,d0			;'@'
		beq	L007166
		cmp.b	#$2a,d0			;'*'
		beq	L007120
		cmp.b	#$3b,d0			;';'
		beq	L006fe0
		cmp.b	#$26,d0			;'&'
		beq	L007236
		cmp.b	#$4e,d0			;'N'
		beq	L007188
		cmp.b	#$6e,d0			;'n'
		beq	L007188
		cmp.b	#$41,d0			;'A'
		bcs	L0072b8
		cmp.b	#$48,d0			;'H'
		bcs	L007188
		cmp.b	#$61,d0			;'a'
		bcs	L0072b8
		cmp.b	#$68,d0			;'h'
		bcs	L007188
		bra	L0072b8
L00704a:
		movea.l	-$31e(a5),a0
		pea.l	(a1)
		movea.l	a0,a1
L007052:
		subq.l	#1,-$31a(a5)
		bmi	L007076
		tst.b	(a1)
		beq	L007076
		cmpi.b	#$d,(a1)+
		bne	L007052
		clr.b	-1(a1)
		addq.l	#1,a1
		move.l	a1,-$31e(a5)
		subq.l	#1,-$31a(a5)
		movea.l	(sp)+,a1
		moveq.l	#0,d0
		rts
L007076:
		moveq.l	#$ff,d0
		movea.l	(sp)+,a1
		rts

L00707c:
		cmpi.b	#$20,(a0)		;' '
		beq	L00708a
		cmpi.b	#9,(a0)
		beq	L00708a
		rts
L00708a:
		addq.l	#1,a0
		bra	L00707c

L00708e:
		movem.l	d1-d7/a1-a6,-(sp)
		moveq.l	#0,d1
		moveq.l	#0,d0
L007096:
		move.b	(a0)+,d0
		sub.b	#$30,d0			;'0'
		bcs	L0070b2
		cmp.b	#$a,d0
		bcc	L0070b2
		add.l	d1,d1
		move.l	d1,d2
		add.l	d1,d1
		add.l	d1,d1
		add.l	d2,d1
		add.l	d0,d1
		bra	L007096
L0070b2:
		move.l	d1,d0
		movem.l	(sp)+,d1-d7/a1-a6
		rts

L0070ba:
		tst.w	-$302(a5)
		bmi	L0070c8
		move.w	-$302(a5),-(sp)
		DOS	_CLOSE
		addq.l	#2,sp
L0070c8:
		addq.l	#1,a0
		bsr	L00707c
		movem.l	a0-a1,-(sp)
		link	a5,#-128
		lea.l	-$80(a5),a1
L0070d8:
		move.b	(a0)+,(a1)+
		bne	L0070d8
		pea.l	dext_pdx(pc)
		pea.l	-$80(a5)
		bsr	L006dd0
		pea.l	env_madrv(pc)
		pea.l	-$80(a5)
		bsr	L006c44
		unlk	a5
		movem.l	(sp)+,a0-a1
		tst.l	d0
		bmi	L0072bc
		move.w	d0,-$302(a5)
		pea.l	$300.w
		pea.l	-$300(a5)
		move.w	d0,-(sp)
		DOS	_READ
		lea.l	$a(sp),sp
		tst.l	d0
		bmi	L0072c0
		bra	L006fe0

L007120:
		tst.w	-$302(a5)
		bmi	L0072c4
		addq.l	#1,a0
		bsr	L00707c
		bsr	L00708e
		mulu.w	#$300,d0
		move.w	#0,-(sp)
		move.l	d0,-(sp)
		move.w	-$302(a5),-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		tst.l	d0
		bmi	L0072c0
		pea.l	$300.w
		pea.l	-$300(a5)
		move.w	-$302(a5),-(sp)
		DOS	_READ
		lea.l	$a(sp),sp
		tst.l	d0
		bmi	L0072c0
		bra	L006fe0

L007166:
		addq.l	#1,a0
		bsr	L00707c
		bsr	L00708e
		cmp.w	-$316(a5),d0
		bpl	L0072c4
		move.w	d0,-$314(a5)
		mulu.w	#$300,d0
		move.l	d0,-$312(a5)
		bra	L006fe0

L007188:
		bsr	L0072de
		tst.l	d0
		bmi	L0072c8
		move.w	d0,d7
		bsr	L00707c
		cmpi.b	#$3d,(a0)+		;'='
		bne	L0072b8
		bsr	L00707c
		bsr	L0072de
		tst.l	d0
		bmi	L0072c8
		move.w	d0,d6
		tst.w	-$302(a5)
		bmi	L0072c4
		add.w	d0,d0
		add.w	d0,d0
		add.w	d0,d0
		lea.l	-$300(a5),a1
		adda.w	d0,a1
		move.l	(a1)+,d1
		move.l	(a1)+,d2
		beq	L0072cc
		sub.l	d2,-$30a(a5)
		bcs	L0072b4
		move.w	#0,-(sp)
		move.l	d1,-(sp)
		move.w	-$302(a5),-(sp)
		DOS	_SEEK
		addq.l	#8,sp
		cmp.l	d1,d0
		bne	L0072c0
		move.l	d2,-(sp)
		move.l	-$30e(a5),-(sp)
		move.w	-$302(a5),-(sp)
		DOS	_READ
		lea.l	$a(sp),sp
		cmp.l	d2,d0
		bne	L0072c0
		move.l	-$30e(a5),d3
		sub.l	-$306(a5),d3
		bmi	L0072b4
		add.l	d2,-$30e(a5)
		movea.l	-$306(a5),a0
		adda.l	-$312(a5),a0
		add.w	d7,d7
		add.w	d7,d7
		add.w	d7,d7
		tst.l	0(a0,d7.w)
		bne	L0072d0
		tst.l	4(a0,d7.w)
		bne	L0072d0
		move.l	d3,0(a0,d7.w)
		move.l	d2,4(a0,d7.w)
		bra	L006fe0

L007236:
		bsr	L0072de
		tst.l	d0
		bmi	L0072c8
		move.w	d0,d7
		bsr	L00707c
		cmpi.b	#$3d,(a0)+		;'='
		bne	L0072b8
		bsr	L00707c
		bsr	L00708e
		move.w	d0,d5
		bsr	L00707c
		bsr	L0072de
		tst.l	d0
		bmi	L0072c8
		move.w	d0,d6
		movea.l	-$306(a5),a0
		adda.l	-$312(a5),a0
		add.w	d7,d7
		add.w	d7,d7
		add.w	d7,d7
		movea.l	-$306(a5),a1
		cmp.w	-$316(a5),d5
		bpl	L0072c4
		mulu.w	#$300,d5
		adda.l	d5,a1
		add.w	d6,d6
		add.w	d6,d6
		add.w	d6,d6
		tst.l	0(a0,d7.w)
		bne	L0072d0
		tst.l	4(a0,d7.w)
		bne	L0072d0
		tst.l	0(a0,d6.w)
		beq	L0072cc
		tst.l	4(a0,d6.w)
		beq	L0072cc
		move.l	0(a0,d6.w),0(a0,d7.w)
		move.l	4(a0,d6.w),4(a0,d7.w)
		bra	L006fe0

L0072b0:
		moveq.l	#$ff,d0
		bra	L0072d6
L0072b4:
		moveq.l	#$fe,d0
		bra	L0072d6
L0072b8:
		moveq.l	#$fd,d0
		bra	L0072d6
L0072bc:
		moveq.l	#$fc,d0
		bra	L0072d6
L0072c0:
		moveq.l	#$fb,d0
		bra	L0072d6
L0072c4:
		moveq.l	#$fa,d0
		bra	L0072d6
L0072c8:
		moveq.l	#$f9,d0
		bra	L0072d6
L0072cc:
		moveq.l	#$f8,d0
		bra	L0072d6
L0072d0:
		moveq.l	#$f7,d0
		bra	L0072d6
L0072d4:
		moveq.l	#0,d0
L0072d6:
		unlk	a5
		movem.l	(sp)+,d1-d7/a0-a6
		rts

L0072de:
		clr.w	d0
		move.b	(a0)+,d0
		andi.b	#$df,d0
		cmp.b	#$4e,d0			;'N'
		beq	L0072fc
		cmp.b	#$41,d0			;'A'
		bcs	L0072f8
		cmp.b	#$48,d0			;'H'
		bcs	L007318
L0072f8:
		moveq.l	#$ff,d0
		rts

L0072fc:
		bsr	L00707c
		bsr	L00708e
		tst.w	d0
		bmi	L0072f8
		cmp.w	#$60,d0			;'`'
		bpl	L0072f8
		rts

L007310:
		.dc.b	$09,$0b,$00,$02,$04,$05,$07,$00


L007318:
		clr.w	d1
		sub.b	#$41,d0			;'A'
		move.b	L007310(pc,d0.w),d1
		bsr	L00707c
		cmpi.b	#$2b,(a0)		;'+'
		beq	L007334
		cmpi.b	#$2d,(a0)		;'-'
		beq	L00733a
		bra	L00733e
L007334:
		addq.w	#1,d1
		addq.l	#1,a0
		bra	L00733e
L00733a:
		subq.w	#1,d1
		addq.l	#1,a0
L00733e:
		bsr	L00707c
		bsr	L00708e
		mulu.w	#$c,d0
		add.w	d1,d0
		subq.w	#4,d0
		bcs	L0072f8
		cmp.w	#$60,d0			;'`'
		bpl	L0072f8
		rts






PLAY_FILE::
		movem.l	d1-d2/a0-a1,-(sp)
		link	a5,#-96
		movea.l	a0,a1
		pea.l	-$60(a5)
		move.l	a1,-(sp)
		DOS	_NAMECK
		addq.l	#8,sp
		tst.l	d0
		bne	L00739c
		move.l	-$a(a5),d1
		andi.l	#$dfdfdf,d1
		DRIVER	DRIVER_FILEEXT
		movea.l	d0,a0
L007382:
		moveq.l	#0,d0
		move.b	(a0),d0
		beq	L00739c
		move.l	(a0)+,d2
		andi.l	#$dfdfdf,d2
		cmp.l	d2,d1
		bne	L007382
		DRIVER	DRIVER_FLOADP
		bra	L00739e
L00739c:
		moveq.l	#$ff,d0
L00739e:
		unlk	a5
		movem.l	(sp)+,d1-d2/a0-a1
		rts

*
* OvZXs
*
* IN	A0.L : s FILENAME
*	A1.L : 
*
		.OFFSET	-512
EXEC_FNAM:	.DS.B	256
EXEC_ARGV:	.DS.B	256
		.TEXT

EXEC_EXTERNAL::
		MOVEM.L	D1-D7/A0-A6,-(SP)
		LINK	A5,#EXEC_FNAM

		LEA.L	EXEC_FNAM(A5),A2
		LEA.L	PATH_CACHE(A6),A3
		TST.B	(A3)				* LbVo^Ȃʏ퓮
		BEQ	EXEC_PR10

* LbV̎擾
		MOVEM.L	A0-A2,-(SP)			* IN A0-A2 ۑ
EXEC_PR2:
		MOVE.B	(A3)+,(A2)+			* pXݒ
		BNE	EXEC_PR2
		SUBQ.L	#1,A2
EXEC_PR22:
		MOVE.B	(A0)+,D0			* st@Cݒ
		BEQ	EXEC_PR23			* ' '  NULL o܂
		CMPI.B	#' ',D0
		BEQ	EXEC_PR23
		MOVE.B	D0,(A2)+
		BRA	EXEC_PR22
EXEC_PR23:
		CLR.B	(A2)				* PATH + FILENAME ͂܂

		MOVEQ.L	#$00,D1				* ̃JE^NA
		LEA.L	EXEC_ARGV+1(A5),A2		* ̈ݒ

		CMPI.B	#' ',D0				* ' ' ꍇ͈̎c肠
		BNE	EXEC_PR24
		MOVEA.L	A0,A4				* cZbg
		BSR	SET_ARGV
		SUBQ.L	#1,A2
		MOVE.B	#' ',(A2)+			* ' ' Pǉ
		ADDQ.B	#1,D1				* {P
EXEC_PR24:
		MOVE.L	A1,A4				* {̈Zbg
		BSR	SET_ARGV
		MOVE.B	D1,EXEC_ARGV(A5)		* ̕Zbg

		MOVEM.L	(SP)+,A0-A2			* IN A0-A2 AĂ
		BSR	EXEC_MAIN0			* DOS _EXEC(0) s
		BPL	EXEC_PR_E			* nj

*
* ss^LbVɂȂ͂i]̓j
*
EXEC_PR10:
		MOVE.W	#254-1,D0
EXEC_PR11:
		MOVE.B	(A0)+,(A2)+			* st@C
		DBEQ.W	D0,EXEC_PR11
		BNE	EXEC_PR15			* t@CȂ

		MOVE.B	#' ',-1(A2)
EXEC_PR12:
		MOVE.B	(A1)+,(A2)+			* ݒ
		DBEQ.W	D0,EXEC_PR12
		BNE	EXEC_PR15			* Ȃ
		CLR.B	(A2)

		PEA.L	0.W				* PATH SEARCH
		PEA.L	EXEC_ARGV(A5)
		PEA.L	EXEC_FNAM(A5)
		MOVE.W	#$0002,-(SP)
		DOS	_EXEC
		TST.L	D0
		BMI	EXEC_PR15

		BSR	EXEC_MAIN0
		BSR	WRITE_PATHCACHE
		MOVEQ.L	#$00,D0
		BRA	EXEC_PR_E

EXEC_PR15:
		MOVEQ.L	#$FF,D0
EXEC_PR_E:
		UNLK	A5
		MOVEM.L	(SP)+,D1-D7/A0-A6
		RTS

*
* SET ARGV PARAMETER
*
* IN	A2.L : EXEC_ARGV(A5)
*	A4.L : ARGV PARAMETER
* OUT	D1.B : ARGV STRINGS COUNTERi݌vj
*
SET_ARGV:
		MOVEQ.L	#$00,D0
SET_ARGV2:
		MOVE.B	(A4)+,(A2)+
		BEQ	SET_ARGV3
		ADDQ.B	#1,D0				* +1
		BRA	SET_ARGV2
SET_ARGV3:
		ADD.B	D0,D1				* Z
		RTS

*
* WRITE PATH TO PATH-CACHE
*
* BRK	D0,D1,A2,A3
*
WRITE_PATHCACHE:
		LEA.L	EXEC_FNAM(A5),A2		* PATH + FILENAME
		LEA.L	PATH_CACHE(A6),A3
		MOVE.L	A2,D1				* ۑ
* Ō '\' '/' T
WRT_PATHC2:
		TST.B	(A2)+
		BNE	WRT_PATHC2
WRT_PATHC3:
		MOVE.B	-(A2),D0
		CMPI.B	#'\',D0
		BEQ	WRT_PATHC4
		CMPI.B	#'/',D0
		BNE	WRT_PATHC3
WRT_PATHC4:
* '\/' or '/\' `FbN 97-06-27			  ȂÔ߁B
		SUBQ.L	#1,A2
		MOVE.B	(A2),D0
		CMPI.B	#'/',D0
		BEQ	WRT_PATHC42
		CMPI.B	#'\',D0
		BEQ	WRT_PATHC42
		ADDQ.L	#1,A2
WRT_PATHC42:
		CLR.B	$01(A2)				* Ō '\' '/' ̎̕  NULL 
		MOVEA.L	D1,A2				* A
* ̃pXLbVɏ
WRT_PATHC5:
		MOVE.B	(A2)+,(A3)+
		BNE	WRT_PATHC5
		RTS

*
* DOS _EXEC(0) MAIN
*
EXEC_MAIN0:
		ST.B	CHILD_FLAG(A6)
		MOVEM.L	D1-D7/A0-A6,-(SP)
		PEA.L	0.W
		PEA.L	EXEC_ARGV(A5)
		PEA.L	EXEC_FNAM(A5)
		MOVE.W	#$0000,-(SP)
		DOS	_EXEC
		LEA.L	14(SP),SP
		MOVEM.L	(SP)+,D1-D7/A0-A6
		CLR.B	CHILD_FLAG(A6)
		TST.L	D0
		RTS

*
* READ MPF(mmdsp palet file)
*
mpf_setup::
		MOVEM.L	D0/A0-A1,-(SP)
*
		MOVE.L	A1,A0
		BSR	read_1k_bytes
		LEA.L	FILE_BUFF+ENV_PALET(A6),A0
		LEA.L	text_palet(PC),A1
		MOVE.L	#$200,D0
		BSR	HSCOPY
		LEA.L	TPALET_BLOCK0,A1
		BSR	HSCOPY
		BSR	PUT_PALETINFO
*
		MOVEM.L	(SP)+,D0/A0-A1
		RTS

*	-	-	-	-	-	-	-	-	*
*	mmdsp ̃G[bZ[W\				*
*	-	-	-	-	-	-	-	-	*
mmdsp_error_message_out::
		MOVEM.L	D0/A1-A2,-(SP)
		SUBQ.W	#1,D0
		CMPI.W	#$1B,D0
		BLS	@f
		CLR.W	D0
@@:
		LEA.L	FILE_BUFF(A6),A2
		ADD.W	D0,D0
		MOVE.W	ERRMES_TBL(PC,D0.W),D0
		LEA.L	ERRMES_TBL(PC,D0.W),A1
L007420:
		MOVE.B	(A0)+,(A2)+
		BNE	L007420
		MOVE.B	#':',-1(A2)
		MOVE.B	#' ',(A2)+
		CMPI.B	#'%',(A1)
		BNE	L007460
		ADDQ.L	#1,A1
		MOVE.B	(A1)+,D0
		CMPI.B	#'D',D0
		BNE	L007452
		MOVE.L	A0,-(SP)
		DRIVER	DRIVER_NAME
		MOVEA.L	D0,A0
L007448:
		MOVE.B	(A0)+,(A2)+
		BNE	L007448
		SUBQ.L	#1,A2
		MOVE.L	(SP)+,A0
		BRA	L007460
L007452:
		CMPI.B	#'P',D0
		BNE	L007460
		MOVE.B	#' ',-2(A2)
		SUBQ.L	#1,A2
L007460:
		MOVE.B	(A1)+,(A2)+
		BNE	L007460
		LEA.L	FILE_BUFF(A6),A0
		MOVEM.L	(SP)+,D0/A1-A2
		RTS

ERRMES_TBL:
		.DC.W	ERR01_MES-ERRMES_TBL
		.DC.W	ERR02_MES-ERRMES_TBL
		.DC.W	ERR03_MES-ERRMES_TBL
		.DC.W	ERR04_MES-ERRMES_TBL
		.DC.W	ERR05_MES-ERRMES_TBL
		.DC.W	ERR06_MES-ERRMES_TBL
		.DC.W	ERR07_MES-ERRMES_TBL
		.DC.W	ERR08_MES-ERRMES_TBL
		.DC.W	ERR09_MES-ERRMES_TBL
		.DC.W	ERR0a_MES-ERRMES_TBL
		.DC.W	ERR0b_MES-ERRMES_TBL
		.DC.W	ERR0c_MES-ERRMES_TBL
		.DC.W	ERR0d_MES-ERRMES_TBL
		.DC.W	ERR0e_MES-ERRMES_TBL
		.DC.W	ERR0f_MES-ERRMES_TBL
		.DC.W	ERR10_MES-ERRMES_TBL
		.DC.W	ERR11_MES-ERRMES_TBL
		.DC.W	ERR12_MES-ERRMES_TBL
		.DC.W	ERR13_MES-ERRMES_TBL
		.DC.W	ERR14_MES-ERRMES_TBL
		.DC.W	ERR15_MES-ERRMES_TBL
		.DC.W	ERR16_MES-ERRMES_TBL
		.DC.W	ERR17_MES-ERRMES_TBL
		.DC.W	ERR18_MES-ERRMES_TBL
		.DC.W	ERR19_MES-ERRMES_TBL
		.DC.W	ERR1a_MES-ERRMES_TBL
		.DC.W	ERR1b_MES-ERRMES_TBL

ERR01_MES:	.DC.B	'G[܂',0
ERR02_MES:	.DC.B	'ȃf[^[hł܂',0
ERR03_MES:	.DC.B	'PCM f[^[hł܂',0
ERR04_MES:	.DC.B	'F`f[^[hł܂',0
ERR05_MES:	.DC.B	'܂',0
ERR06_MES:	.DC.B	'%D ̃o[WႢ܂',0
ERR07_MES:	.DC.B	'%D ̃gbNobt@܂',0
ERR08_MES:	.DC.B	'%D  PCM obt@܂',0
ERR09_MES:	.DC.B	'%D ̃[Ns̉\܂',0
ERR0a_MES:	.DC.B	'ُȃf[^ł',0
ERR0b_MES:	.DC.B	'PCM f[^ُł',0
ERR0c_MES:	.DC.B	'%P ܂',0
ERR0d_MES:	.DC.B	'MIDI {[h܂',0
ERR0e_MES:	.DC.B	'Ro[gɎs܂',0
ERR0f_MES:
.ifdef USE_LZM
		.DC.B	'LZM(LZZ) ܂',0
.endif
ERR10_MES:	.DC.B	'LZZ ܂',0
ERR11_MES:	.DC.B	'LZZ œWJɎs܂',0
ERR12_MES:	.DC.B	'Ro[^ (??toZ) ܂',0
ERR13_MES:	.DC.B	'f[^̎ނႢ܂',0
ERR14_MES:	.DC.B	'%D ŃG[܂',0
ERR15_MES:	.DC.B	'Ro[gɈُȃR[h𔭌܂',0
ERR16_MES:	.DC.B	'݂ł܂',0
ERR17_MES:	.DC.B	't@C܂',0
ERR18_MES:	.DC.B	'obt@sł',0
ERR19_MES:	.DC.B	'RC ̃Ro[^ŃG[܂',0
ERR1a_MES:	.DC.B	'RC ̃Ro[^(?toR)܂',0
ERR1b_MES:
.ifdef HUMAN_VERSION_CHECK
		.DC.B	'Human ̃o[W߂܂',0
.endif

L00774d::	.DC.B	'MMDSP',0
		.EVEN

*
* ENVIROMENT VALUE
*
env_madrv::
		.DC.B	'MADRV',0
env_lzzpath::
		.DC.B	'LZZPATH',0
env_mxp::
		.DC.B	'mxp',0

.ifdef SEARCH_LZZ_RX
fname_lzz_r:
		.DC.B	'lzz.r',0
fname_lzz_x:
		.DC.B	'lzz.x',0		*** for ITA LZXed LZZ
.endif
fname_lzz:
		.DC.B	'lzz',0			*** for execd LZZ
.ifdef USE_LZM
fname_lzm:
		.DC.B	'lzm.r',0
.endif

dext_mdx::
		.DC.B	'.mdx',0
dext_pdx::
		.DC.B	'.pdx',0
dext_zdf::
		.DC.B	'.zdf',0



		.END
