*
*	multi music status display MMDSP v0.29 Rel.10
*
*			program parts of 'INITIALIZE'
*

		.include	doscall.mac
		.include	iocscall.mac
		.include	mmdsp.equ
		.include	patchlevel.equ


* Global Symbol ------------------------------- *

		.xref	_JnAhX
		.xref	_I[AhX
		.xref	ANIM_PANEL
		.xref	search_driver
		.xref	SEARCH_PCMDRV
		.xref	text_palet
		.xref	text_screen_clear
		.xref	MOUSE_INIT
		.xref	L001254
		.xref	SYSDISP_MAKE
		.xref	KEYBOARD_MAKE
		.xref	LEVELMETER_MAKE
		.xref	PANEL_MAKE
		.xref	SPEANA_MAKE
		.xref	SPEANA_MAKE_2
		.xref	SELECTOR_MAKE
		.xref	GET_CURRENT
		.xref	SET_CURRENT


* Text Section -------------------------------- *

		.cpu	68000
		.text


*
* SETBLOCK / Human VERSION CHECK
*
SETBLOCK_VERNUM::
		MOVEM.L	A0-A2,-(SP)
		LINK	A5,#0

		MOVEA.L	A0,A2
		MOVEA.L	$30(A0),A1
		LEA.L	16(A0),A0
		ADDA.L	#USER_SP,A1
		SUBA.L	A0,A1
		MOVE.L	A1,-(SP)
		MOVE.L	A0,-(SP)
		DOS	_SETBLOCK
		TST.L	D0
		BPL	SETBLOCK_VERNUM2

		PEA.L	MEMORY_MES(PC)
		DOS	_PRINT
		MOVEQ.L	#8,D0
		BSET.L	#31,D0
		BRA	SETBLOCK_VERNUM4
SETBLOCK_VERNUM2:
		LEA.L	_JnAhX(PC),A6
		ADDA.L	#(_I[AhX-_JnAhX),A6
		BSR	FLUSH_WORK
		BSR	SET_INIT_FADESPEED
		MOVE.L	A2,MM_MEMPTR(A6)

* MMDSP 擪AhXi[ 97-04-13, 97-04-21
		LEA.L	$100(A2),A0
		MOVE.L	A0,MMDSP_TOPADR(A6)

		PEA.L	TITLE(PC)
		DOS	_PRINT

.ifdef HUMAN_VERSION_CHECK
* Human V3 ȍ~̂ݓ 97-03-15
		DOS	_VERNUM
		CMPI.W	#$0300,D0
		BCC	SETBLOCK_VERNUM3
		PEA.L	OSERR_MES(PC)
		DOS	_PRINT
		MOVEQ.L	#$FF,D0
		BRA	SETBLOCK_VERNUM4
.endif

* MPU TYPE 擾 97-05-12
SETBLOCK_VERNUM3:
		LEA.L	$CBC.W,A1
		IOCS	_B_BPEEK
		MOVE.B	D0,MPU_TYPE(A6)
		MOVEQ.L	#$00,D0
SETBLOCK_VERNUM4:
		UNLK	A5
		MOVEM.L	(SP)+,A0-A2
		TST.L	D0
		RTS

*
* FLUSH MMDSP WORK AREA
*
FLUSH_WORK:
		MOVEM.L	D0-D1/A6,-(SP)
		MOVE.W	#(FILE_BUFF/2)-1,D1
		MOVEQ.L	#0,D0
FLUSH_WORK2:
		MOVE.W	D0,(A6)+
		DBRA.W	D1,FLUSH_WORK2
		MOVEM.L	(SP)+,D0-D1/A6
		RTS

*
* SET FADEOUT INITIAL SPEED
*
SET_INIT_FADESPEED:
		MOVEM.L	A0-A1,-(SP)
		LEA.L	FADE_BASEDATA(PC),A0
		LEA.L	FADE_BASE(A6),A1
		MOVE.L	(A0)+,(A1)+		* mxdrv, madrv
		MOVE.L	(A0)+,(A1)+		* mld, rcd
		MOVE.L	(A0)+,(A1)+		* zmusic, mcdrv
		MOVE.W	(A0)+,(A1)+		* faldrv
		MOVEM.L	(SP)+,A0-A1
		RTS

FADE_BASEDATA:
		.DC.W	20			* mxdrv
		.DC.W	23			* madrv
		.DC.W	18			* mld
		.DC.W	5			* rcd
		.DC.W	40			* zmusic
		.DC.W	10			* mcdrv
		.DC.W	20			* faldrv

*
* ADD ENVIROMENT VALUE TO A2 REGISTER
*
ADD_ENVVALUE::
		MOVEM.L	A0/A2,-(SP)
		LINK	A5,#-256
		LEA.L	-256(A5),A0
		MOVE.L	A0,-(SP)
		PEA.L	0.W
		PEA.L	ENV_MMDSPCMD(PC)
		DOS	_GETENV
		TST.L	D0
		BMI	ADD_ENV4
		ST.B	(A2)		* _~[Zbg
ADD_ENV2:
		TST.B	(A2)+
		BNE	ADD_ENV2
		MOVE.B	#' ',-1(A2)
ADD_ENV3:
		MOVE.B	(A0)+,(A2)+
		BNE	ADD_ENV3
		CLR.B	-1(A2)
ADD_ENV4:
		UNLK	A5
		MOVEM.L	(SP)+,A0/A2
		RTS

ENV_MMDSPCMD:
		.DC.B	'mmdspcmd',0
		.EVEN

*	-	-	-	-	-	-	-	-	*
*	R}hC̃`FbN					*
*	-	-	-	-	-	-	-	-	*
CHECK_CMDLINE::
		MOVEQ.L	#0,D0
		TST.B	(A2)+
		BEQ	CHECK_CMDLINE3
		MOVEM.L	D1/A0/A2,-(SP)
CHECK_CMDLINE2:
		BSR	CHECK_CMDLINE4
		BGT	CHECK_CMDLINE2
		MOVEM.L	(SP)+,D1/A0/A2
CHECK_CMDLINE3:
		RTS

CHECK_CMDLINE4:
		BSR	SKIP_SPACE
		MOVE.B	(A2)+,D0
		BEQ	CHECK_CMDLINE5
		CMPI.B	#'-',D0
		BEQ	CHECK_SWITCH
		CMPI.B	#'/',D0
		BEQ	CHECK_SWITCH
		SUBQ.L	#1,A2
		BRA	CHECK_PATH
CHECK_CMDLINE5:
		MOVEQ.L	#0,D0
		RTS

*
* CHECK COMMAND SWITCH
*
CHECK_SWITCH:
		BSR	MATCH_SWITCH
		BMI	USAGE
		BSR	SWITCH_JUMP
		BMI	USAGE
		MOVEQ.L	#1,D0
		RTS
*
* CHECK COMLINE - PATH
*
CHECK_PATH:
		LEA.L	CURRENT(A6),A0
		TST.B	(A0)
		BNE	USAGE
CHECK_PATH2:
		CMPI.B	#' ',(A2)
		BLS	CHECK_PATH3
		MOVE.B	(A2)+,(A0)+
		BRA	CHECK_PATH2
CHECK_PATH3:
		CLR.B	(A0)
		MOVEQ.L	#1,D0
		RTS

USAGE:
		PRINT	USAGE_MES(PC)
		MOVEQ.L	#$FF,D0
		RTS

*
* CHECK MATCH SWITCH ?
*
MATCH_SWITCH:
		MOVEM.L	D1-D2/A0-A1,-(SP)
		LEA.L	SWITCH_TABLE(PC),A1
		MOVEQ.L	#0,D2
MATCH_SW2:
		MOVEA.L	A2,A0
MATCH_SW3:
		MOVE.B	(A1)+,D1
		BEQ	MATCH_SW5
		MOVE.B	(A0)+,D0
		ORI.B	#$20,D0
		CMP.B	D1,D0
		BEQ	MATCH_SW3
MATCH_SW4:
		TST.B	(A1)+
		BNE	MATCH_SW4
		TST.B	(A1)
		BEQ	NOTMATCH
		ADDQ.L	#1,D2
		BRA	MATCH_SW2
MATCH_SW5:
		MOVEA.L	A0,A2
		MOVE.L	D2,D0
		MOVEM.L	(SP)+,D1-D2/A0-A1
		RTS

NOTMATCH:
		MOVEQ.L	#$FF,D0
		MOVEM.L	(SP)+,D1-D2/A0-A1
		RTS

*
* COMPARED SWITCH TABLE
*
SWITCH_TABLE:
		.DC.B	'mxdrv',0
		.DC.B	'madrv',0
		.DC.B	'mld',0
		.DC.B	'rcd',0
		.DC.B	'zmusic',0
		.DC.B	'mcdrv',0
		.DC.B	'nodef',0			* ADDITIONAL

		.DC.B	'g',0
		.DC.B	'a',0
		.DC.B	's',0
		.DC.B	'n',0
		.DC.B	'f',0
		.DC.B	'k',0
		.DC.B	'r',0
		.DC.B	't',0				* ADDITIONAL
		.DC.B	'c',0				* ADDITIONAL
		.DC.B	'i',0				* ADDITIONAL
		.DC.B	'p',0				* ADDITIONAL
		.DC.B	0
		.EVEN

*
* IF MATCH SWITCH, JUMP
*
SWITCH_JUMP:
		ADD.W	D0,D0
		MOVE.W	SWITCH_JMPTBL(PC,D0.W),D0
		JSR	SWITCH_JMPTBL(PC,D0.W)
		RTS

SWITCH_JMPTBL:
		.DC.W	SWITCH_MXDRV-SWITCH_JMPTBL
		.DC.W	SWITCH_MADRV-SWITCH_JMPTBL
		.DC.W	SWITCH_MLD-SWITCH_JMPTBL
		.DC.W	SWITCH_RCD-SWITCH_JMPTBL
		.DC.W	SWITCH_ZMUSIC-SWITCH_JMPTBL
		.DC.W	SWITCH_MCDRV-SWITCH_JMPTBL
		.DC.W	NOREAD_DEFFILE-SWITCH_JMPTBL	* ADDITIONAL
		.DC.W	SWITCH_G-SWITCH_JMPTBL
		.DC.W	SWITCH_A-SWITCH_JMPTBL
		.DC.W	SWITCH_S-SWITCH_JMPTBL
		.DC.W	SWITCH_N-SWITCH_JMPTBL
		.DC.W	SWITCH_F-SWITCH_JMPTBL
		.DC.W	SWITCH_K-SWITCH_JMPTBL
		.DC.W	SWITCH_R-SWITCH_JMPTBL
		.DC.W	TONEDOWN_SEC-SWITCH_JMPTBL	* ADDITIONAL
		.DC.W	CONTRAST-SWITCH_JMPTBL		* ADDITIONAL
		.DC.W	SETUSEINT-SWITCH_JMPTBL		* ADDITIONAL
		.DC.W	PALETANIM_OFF-SWITCH_JMPTBL	* ADDITIONAL

SWITCH_MXDRV:
		MOVE.W	#1,DRV_MODE(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_MADRV:
		MOVE.W	#2,DRV_MODE(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_MLD:
		MOVE.W	#3,DRV_MODE(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_RCD:
		MOVE.W	#4,DRV_MODE(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_ZMUSIC:
		MOVE.W	#5,DRV_MODE(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_MCDRV:
		MOVE.W	#6,DRV_MODE(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_G:
		MOVEQ.L	#1,D0
		BSR	STR2DEC
		CMPI.B	#3,D0
		BHI	SWITCH_ERR
		MOVE.B	D0,GRAPH_MODE(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_A:
		MOVE.B	#1,AUTOMODE(A6)
		BRA	SWITCH_A_S
SWITCH_S:
		MOVE.B	#2,AUTOMODE(A6)
SWITCH_A_S:
		MOVEQ.L	#0,D0
		BSR	STR2BIT
		TST.L	D0
		BMI	SWITCH_ERR
		MOVE.B	D0,AUTOFLAG(A6)
		MOVEQ.L	#0,D0
		RTS

*
* STRINGS  BIT
*
STR2BIT:
* w莞͋A 97-05-07
		TST.B	(A2)
		BEQ	STR2BIT5
		CMPI.B	#' ',(A2)
		BEQ	STR2BIT5

		MOVEM.L	D1-D2/D7,-(SP)
		MOVE.B	(A2),D0
		SUBI.B	#'0',D0
		CMPI.B	#1,D0
		BHI	STR2BIT4
		MOVEQ.L	#0,D1
		MOVEQ.L	#$FF,D2
		MOVEQ.L	#4-1,D7
STR2BIT2:
		MOVEQ.L	#0,D0
		MOVE.B	(A2),D0
		SUBI.B	#'0',D0
		CMPI.B	#1,D0
		BHI	STR2BIT3
		ADDQ.L	#1,A2
		LSL.L	#3,D0
		LSR.L	D7,D0
		ADD.L	D0,D1
		DBRA.W	D7,STR2BIT2
		MOVE.L	D1,D2
STR2BIT3:
		MOVE.L	D2,D0
STR2BIT4:
		MOVEM.L	(SP)+,D1-D2/D7
STR2BIT5:
		RTS

SWITCH_N:
		ST.B	SEL_NOUSE(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_F:
		ST.B	FORCE_TVRAM(A6)
		MOVEQ.L	#0,D0
		RTS

SWITCH_K:
		ST.B	RESIDENT(A6)
		MOVEQ.L	#$58,D0
		BSR	STR2HEX
		ANDI.W	#$7F,D0
		MOVE.B	D0,HOTKEY1(A6)
		BSET.B	D0,HOTKEY1MASK(A6)
		LSR.B	#3,D0
		ADDI.W	#$800,D0
		MOVE.W	D0,HOTKEY1ADR(A6)
		MOVEQ.L	#$59,D0
		CMPI.B	#',',(A2)
		BNE	SWITCH_K2
		ADDQ.L	#1,A2
		BSR	STR2HEX
SWITCH_K2:
		ANDI.W	#$7F,D0
		MOVE.B	D0,HOTKEY2(A6)
		BSET.B	D0,HOTKEY2MASK(A6)
		LSR.B	#3,D0
		ADDI.W	#$800,D0
		MOVE.W	D0,HOTKEY2ADR(A6)
		CMP.W	HOTKEY1ADR(A6),D0
		BNE	SWITCH_K3
		MOVE.B	HOTKEY2MASK(A6),D0
		OR.B	HOTKEY1MASK(A6),D0
		MOVE.B	D0,HOTKEY1MASK(A6)
		MOVE.B	D0,HOTKEY2MASK(A6)
SWITCH_K3:
		MOVEQ.L	#0,D0
		RTS

SWITCH_R:
		ST.B	REMOVE(A6)
		MOVEQ.L	#0,D0
		RTS

*
* '-t[sec]' : g[_E܂ł̕bw
*
TONEDOWN_SEC:
		MOVEQ.L	#0,D0
		BSR	STR2DEC
		TST.L	D0
		BNE	TONEDOWN_SEC2
		MOVE.W	#180,d0
TONEDOWN_SEC2:
		CMPI.L	#35791393,D0
		BHI	SWITCH_ERR
		ADD.L	D0,D0			* ~1/60 = bɕϊ
		ADD.L	D0,D0
		MOVE.L	D0,-(SP)
		LSL.L	#4,D0
		SUB.L	(SP)+,D0

* MC68030 ȍ~Ȃ萳mȕbZo 97-05-12
		CMPI.B	#3,MPU_TYPE(A6)
		BCS	TONEDOWN_SEC3
			.CPU	68030
		MOVE.L	D1,-(SP)
		MOVEQ.L	#0,D1
		MULU.L	#95,D1:D0		* ~95
		DIVU.L	#100,D1:D0		* 100
		SUBI.L	#60*2,D0		* - 120
		MOVE.L	(SP)+,D1
			.CPU	68000
TONEDOWN_SEC3:
		MOVE.L	D0,NO_KEYINSEC(A6)
		MOVE.L	D0,NO_KEYINCNT(A6)
		MOVEQ.L	#0,D0
		RTS

*
* '-c[n]' : g[_E̖邳w
*
CONTRAST:
		MOVEQ.L	#5,D0
		BSR	STR2DEC
		CMPI.B	#15,D0
		BHI	SWITCH_ERR
		MOVE.W	D0,CONTRAST_NUM(A6)
		MOVEQ.L	#$00,D0
		RTS

*
* '-i[n]' : gp銄荞݂w
*
SETUSEINT:
		MOVEQ.L	#1,D0
		BSR	STR2DEC
		CMPI.B	#4+1,D0
		BCC	SWITCH_ERR
*
		add	d0,d0
		sne	(SWITCH_I_FLAG,a6)	* '-i'XCb`tOݒ
		move	d0,(VECTMODE,a6)	* 荞ݎʐݒ
		MOVEQ.L	#$00,D0
		RTS

*
* '-p' : pbgAj[VgȂ
*
PALETANIM_OFF:
		LEA.L	ANIM_PANEL(PC),A0
		CLR.W	(A0)
		MOVEQ.L	#$00,D0
		RTS

*
* '-nodef' : `t@Cǂݍ܂Ȃ
*
NOREAD_DEFFILE:
		ST.B	NODEFREAD_FLAG(A6)
		MOVEQ.L	#$00,D0
		RTS

SWITCH_ERR:
		MOVEQ.L	#$FF,D0
		RTS

*
* STRINGS  DECIMAL
*
STR2DEC:
* w莞͋A 97-05-07
		TST.B	(A2)
		BEQ	STR2DEC4
		CMPI.B	#' ',(A2)
		BEQ	STR2DEC4

		MOVE.L	D1,-(SP)
		MOVEQ.L	#0,D1
		MOVE.B	(A2)+,D1
		SUBI.B	#'0',D1
		CMPI.B	#9,D1
		BHI	STR2DEC3
		MOVE.L	D1,D0
STR2DEC2:
		MOVE.B	(A2)+,D1
		SUBI.B	#'0',D1
		CMPI.B	#9,D1
		BHI	STR2DEC3
		ADD.L	D0,D0
		MOVE.L	D0,-(SP)
		ADD.L	D0,D0
		ADD.L	D0,D0
		ADD.L	(SP)+,D0
		ADD.L	D1,D0
		BRA	STR2DEC2
STR2DEC3:
		SUBQ.L	#1,A2
		MOVE.L	(SP)+,D1
STR2DEC4:
		RTS

*
* STRINGS  HEXADECIMAL
*
STR2HEX:
* w莞͋A 97-05-07
		TST.B	(A2)
		BEQ	STR2HEX6
		CMPI.B	#' ',(A2)
		BEQ	STR2HEX6

		MOVE.L	D1,-(SP)
		MOVE.B	(A2)+,D1
		SUBI.B	#'0',D1
		CMPI.B	#9,D1
		BLS	STR2HEX2
		ADDI.B	#'0',D1
		ANDI.B	#$DF,D1
		SUBI.B	#'7',D1
		CMPI.B	#15,D1
STR2HEX2:
		BHI	STR2HEX5
		MOVE.W	d1,D0
STR2HEX3:
		MOVE.B	(A2)+,D1
		SUBI.B	#'0',D1
		CMPI.B	#9,D1
		BLS	STR2HEX4
		ADDI.B	#'0',D1
		ANDI.B	#$DF,D1
		SUBI.B	#'7',D1
		CMPI.B	#15,D1
STR2HEX4:
		BHI	STR2HEX5
		LSL.W	#4,D0
		ADD.B	D1,D0
		BRA	STR2HEX3
STR2HEX5:
		SUBQ.L	#1,A2
		MOVE.L	(SP)+,D1
STR2HEX6:
		RTS

*
* SKIP SPACE / TAB CODE
*
SKIP_SPACE0:
		ADDQ.L	#1,A2
SKIP_SPACE:
		CMPI.B	#' ',(A2)
		BEQ	SKIP_SPACE0
		CMPI.B	#9,(A2)
		BEQ	SKIP_SPACE0
		RTS

*
* SEARCH USABLE INTERRUPT
*
SEARCH_EMPINT::
		MOVEM.L	D1-D2/D7/A0-A1,-(SP)
		MOVEQ.L	#0,D7
		BSR	search_driver
		TST.L	D0
		BNE	SEARCH_EI2
		BSET.L	#31,D7
		BSET.L	#0,D7
		BRA	SEARCH_EI4
SEARCH_EI2:
		BSR	SEARCH_PCMDRV
		TST.B	FORCE_TVRAM(A6)
		BNE	SEARCH_EI3
		MOVEQ.L	#1,D1
		MOVEQ.L	#$FF,D2
		IOCS	_TGUSEMD
		CMPI.B	#2,D0
		BNE	SEARCH_EI3
		BSET.L	#31,D7
		BSET.L	#1,D7
		BRA	SEARCH_EI4
SEARCH_EI3:
		MOVE.W	#$00FF,D1
		MOVEQ.L	#$00,D0				* FLAG:OFF Ȃ
		MOVE.B	SWITCH_I_FLAG(A6),D0		* ʏ̐R@ɂ
		BEQ	SEARCH_EMPINT2
		MOVE.W	VECTMODE(A6),D0
		move	(SEARCH_INTTBL-2,pc,d0.w),a0
		MOVE.W	(A0),D2
		AND.W	D1,D2
		CMP.W	D1,D2
		BEQ	SEARCH_EI4
*		BRA	SEARCH_EMPINT2			* w肵荞݂gȂ̂
							* ʏ̐R@ɂ
SEARCH_EMPINT2:
		moveq	#2,d0
		MOVE.W	TIMER_A_VECTOR.W,D2
		AND.W	D1,D2
		CMP.W	D1,D2
		BEQ	SEARCH_EI22
		moveq	#4,d0
		MOVE.W	CRTC_VECTOR.W,D2
		AND.W	D1,D2
		CMP.W	D1,D2
		BEQ	SEARCH_EI22
		moveq	#6,d0
		MOVE.W	VDISP_VECTOR.W,D2
		AND.W	D1,D2
		CMP.W	D1,D2
		BEQ	SEARCH_EI22
		moveq	#8,d0
		MOVE.W	TIMER_D_VECTOR.W,D2
		AND.W	D1,D2
		CMP.W	D1,D2
		BEQ	SEARCH_EI22
		BSET.L	#31,D7
		BSET.L	#2,D7
		BRA	SEARCH_EI4
SEARCH_EI22:
		MOVE.W	D0,VECTMODE(A6)
SEARCH_EI4:
		MOVE.L	D7,D0
		MOVEM.L	(SP)+,D1-D2/D7/A0-A1
		RTS


SEARCH_INTTBL:
		.DC.W	TIMER_A_VECTOR
		.DC.W	CRTC_VECTOR
		.DC.W	VDISP_VECTOR
		.DC.W	TIMER_D_VECTOR



*
* CHECK ERROR APPEARANCE
*
CHECK_ERROR::
		MOVEM.L	D0/A0,-(SP)
		BTST.L	#0,D0
		BEQ	CHECK_ERROR3
		LEA.L	DRIVER_MES(PC),A0
		TST.W	DRV_MODE(A6)
		BEQ	CHECK_ERROR2
		LEA.L	DESIGNATED_MES(PC),A0
CHECK_ERROR2:
		PEA.L	(A0)
		BRA	CHECK_ERROR6
CHECK_ERROR3:
		BTST.L	#1,D0
		BEQ	CHECK_ERROR4
		PEA.L	TEXT_MES(PC)
		BRA	CHECK_ERROR6
CHECK_ERROR4:
		BTST.L	#2,D0
		BEQ	CHECK_ERROR5
		PEA.L	NOINT_MES(PC)
		BRA	CHECK_ERROR6
*
* u`荞݂gp܂v\
*
CHECK_ERROR5:
		MOVE.W	VECTMODE(A6),D0
		move	(intkind_table-2,pc,d0.w),d0
		pea	(intkind_table,pc,d0.w)
		DOS	_PRINT
		PEA.L	INTERRUPT_MES(PC)
		DOS	_PRINT
		ADDQ.L	#8,SP
*
* u`[hŋN܂v\
*
		DRIVER	DRIVER_NAME
		MOVE.L	D0,-(SP)
		DOS	_PRINT
		ADDQ.L	#4,SP
		PEA.L	MODE_MES(PC)
CHECK_ERROR6:
		DOS	_PRINT
		ADDQ.L	#4,SP
		MOVEM.L	(SP)+,D0/A0
		TST.L	D0
		RTS

intkind_table:
		.dc	TIMERA_MES-intkind_table
		.dc	RASTER_MES-intkind_table
		.dc	VDISP_MES-intkind_table
		.dc	TIMERD_MES-intkind_table


*==================================================
*hCo֌W̏
*==================================================

DRIVER_INIT::
		MOVEM.L	D0/A0,-(SP)
		LEA.L	TRACK_STATUS(A6),A0
		MOVE.L	A0,KEYB_TRBUF(A6)
		MOVE.L	A0,LEVEL_TRBUF(A6)
		LEA.L	CHST_BF(A6),A0
		MOVE.L	A0,KEYB_CHBUF(A6)
		DRIVER	DRIVER_SETUP
		MOVEM.L	(SP)+,D0/A0
		RTS

*
* SET INTERRUPT VECTOR
*
SET_INTERRUPT::
		MOVEM.L	D0-D1/A0-A1,-(SP)

		move	(VECTMODE,a6),d0
		subq	#4,d0
		bcs	SET_INTERRUPT2		;-i1
		beq	SET_INTERRUPT3		;-i2
		subq	#4,d0
		bcs	SET_INTERRUPT4		;-i3
		bra	SET_INTERRUPT5		;-i4

SET_INTERRUPT2:
		MOVE.W	SR,-(SP)
		ORI.W	#$0700,SR
		MOVE.L	VDISP_VECTOR.W,ORIG_VECTOR(A6)
		MOVE.L	A1,VDISP_VECTOR.W
		LEA.L	$E88009,A1
		BSET.B	#6,(A1)
		BSET.B	#6,$0C(A1)
		MOVE.W	(SP)+,SR
		BRA	SET_INTERRUPT6
SET_INTERRUPT3:
		MOVEQ.L	#0,D1
		IOCS	_CRTCRAS
		BRA	SET_INTERRUPT6
SET_INTERRUPT4:
		MOVEQ.L	#1,D1
		IOCS	_VDISPST
		BRA	SET_INTERRUPT6
SET_INTERRUPT5:
		MOVE.W	#$07FF,D1
		IOCS	_TIMERDST
SET_INTERRUPT6:
		MOVEM.L	(SP)+,D0-D1/A0-A1
		RTS

*
* KEEP CHECK
*
KEEP_CHECK::
		MOVEM.L	D1/A0,-(SP)
		MOVEA.L	MM_MEMPTR(A6),A0
KEEP_CHECK2:
		MOVE.L	(A0),D0
		BEQ	KEEP_CHECK3
		MOVEA.L	D0,A0
		BRA	KEEP_CHECK2
KEEP_CHECK3:
		CMPI.L	#'MMDS',$102(A0)
		BNE	KEEP_CHECK4
		CMPI.L	#'P000',$106(A0)
		BNE	KEEP_CHECK4
		CMPI.L	#'1AY&',$10A(A0)
		BNE	KEEP_CHECK4
		MOVE.L	A0,D0
		BRA	KEEP_CHECK5
KEEP_CHECK4:
		MOVE.L	$0C(A0),D0
		MOVEA.L	D0,A0
		BNE	KEEP_CHECK3
		MOVEQ.L	#$FF,D0
KEEP_CHECK5:
		MOVEM.L	(SP)+,D1/A0
		RTS

*
* IGNORE [BREAK] MODE
*
IGNORE_BREAK::
		MOVE.W	#$FFFF,-(SP)
		DOS	_BREAKCK
		MOVE.W	D0,BREAKCK_SAVE(A6)
		MOVE.W	#2,-(SP)
		DOS	_BREAKCK
		ADDQ.L	#4,SP
		RTS

*
* RESTORE [BREAK] MODE
*
RESTORE_BREAK::
		MOVE.W	BREAKCK_SAVE(A6),-(SP)
		DOS	_BREAKCK
		ADDQ.L	#2,SP
		RTS

*
* IGNORE [INS] KEY
*
IGNORE_INS::
		IOCS	_B_SFTSNS
		LSR.W	#8,D0
		MOVE.B	D0,INS_MODE(A6)
		BTST.L	#4,D0
		BEQ	IGNORE_INS2
		MOVEM.L	D1-D2,-(SP)			* 97-05-15
		MOVEQ.L	#$04,D1
		MOVEQ.L	#$00,D2
		IOCS	_LEDMOD
		MOVEM.L	(SP)+,D1-D2
IGNORE_INS2:
		RTS

*
* RESTORE [INS] KEY
*
RESTORE_INS::
		BTST.B	#4,INS_MODE(A6)
		BEQ	RESTORE_INS2
		MOVEM.L	D1-D2,-(SP)			* 97-05-15
		MOVEQ.L	#$04,D1
		MOVEQ.L	#$01,D2
		IOCS	_LEDMOD
		MOVEM.L	(SP)+,D1-D2
RESTORE_INS2:
		RTS

*
* RELEASE INTERRUPT VECTOR
*
VECTOR_DONE::
		MOVEM.L	D0-D1/A0-A1,-(SP)
		SUBA.L	A1,A1
		move	(VECTMODE,a6),d0
		subq	#4,d0
		bcs	VECTOR_DONE2		;-i1
		beq	VECTOR_DONE3		;-i2
		subq	#4,d0
		bcs	VECTOR_DONE4		;-i3
		bra	VECTOR_DONE5		;-i4

VECTOR_DONE2:
		MOVE.W	SR,-(SP)
		ORI.W	#$0700,SR
		MOVE.L	ORIG_VECTOR(A6),VDISP_VECTOR.W
		LEA.L	$E88009,A1
		BCLR.B	#6,(A1)
		BCLR.B	#6,$0C(A1)
		MOVE.W	(SP)+,SR
		BRA	VECTOR_DONE6
VECTOR_DONE3:
		IOCS	_CRTCRAS
		BRA	VECTOR_DONE6
VECTOR_DONE4:
		IOCS	_VDISPST
		BRA	VECTOR_DONE6
VECTOR_DONE5:
		IOCS	_TIMERDST
VECTOR_DONE6:
		MOVEM.L	(SP)+,D0-D1/A0-A1
		RTS

*
* t@C̃pX擾
*
GET_DEFPATH::
		MOVEM.L	D1/A0-A1,-(SP)
*
		MOVE.B	D0,D1			* D1.B : FLAG ($FF=ERRORCHECK SKIP)
		LEA.L	DEFFILE_PATH(A6),A0

		MOVE.L	A0,-(SP)
		PEA.L	0.W
		PEA.L	DEF_ENVNAME(PC)
		DOS	_GETENV
		LEA.L	12(SP),SP
		TST.L	D0
		BPL	GET_DEFPATH_OPEN	* ϐ

* ϐȂ  {̃pX{MMDSP.DAT
GET_DEFPATH2:
		MOVE.L	A0,-(SP)
		LEA.L	_JnAhX-$80(PC),A1
		MOVE.W	(A1)+,(A0)+
GET_DEFPATH21:
		MOVE.B	(A1)+,(A0)+
		BNE	GET_DEFPATH21
		SUBQ.L	#1,A0
GET_DEFPATH3:
		LEA.L	DEF_BASENAME(PC),A1
GET_DEFPATH31:
		MOVE.B	(A1)+,(A0)+
		BNE	GET_DEFPATH31
		MOVE.L	(SP)+,A0

* ϐ̓eI[vĂ݂
GET_DEFPATH_OPEN:
		MOVE.W	#$0000,-(SP)
		MOVE.L	A0,-(SP)
		DOS	_OPEN
		ADDQ.L	#6,SP
		TST.L	D0
		BPL	GET_DEFPATH_OK

*		CMPI.L	#-2,D0			* D0.L = -2 : FILE NOT FOUND
		ADDQ.W	#2,D0
		BEQ	DEFPATH_NOTFOUND
*		CMPI.L	#-5,D0			* D0.L = -5 : CANNOT ACCESS THE PATH
		ADDQ.W	#3,D0
		BEQ	DEFPATH_ADDNAME
*		CMPI.L	#-13,D0			* D0.L = -13: INCORRECT FILENAME
		ADDQ.W	#8,D0
		BEQ	DEFPATH_ADDNAME
GET_DEFPATH_OK:
		MOVE.W	D0,-(SP)
		DOS	_CLOSE
		ADDQ.L	#2,SP
		MOVEQ.L	#$00,D0
GET_DEFPATH_OK2:
		MOVEM.L	(SP)+,D1/A0-A1
		RTS

* ϐ̃pX猩Ȃ  Jg̒`t@CɃANZX
DEFPATH_NOTFOUND:
		TST.B	D1			*  FLAG:ON Ȃ
		BNE	GET_DEFPATH_OK2		* ϐ̃pXɃANZX
		ST.B	D1
		BRA	GET_DEFPATH2

* ϐɃpX̎w肵Ȃ  ̃pX{MMDSP.DEF
DEFPATH_ADDNAME:
		MOVE.L	A0,-(SP)
DEFPATH_ADDNAME2:
		TST.B	(A0)+
		BNE	DEFPATH_ADDNAME2
		SUBQ.L	#1,A0
*
		CMPI.B	#'\',-1(A0)
		BEQ	GET_DEFPATH3
		CMPI.B	#'/',-1(A0)
		BEQ	GET_DEFPATH3
		MOVE.B	#'\',(A0)+
		BRA	GET_DEFPATH3

*
* `t@Cǂݍ
*
READ_DEFFILE::
		MOVEM.L	D0-D1/A0-A2,-(SP)
		LINK	A5,#-DEFFILE_SIZE

* [CTRL] œǂݍ܂Ȃ 97-06-21
		MOVE.B	$80E.W,D0
		BTST.L	#1,D0
		BNE	READCFG_EXIT

* NXCb` -nodef łǂݍ܂Ȃ 97-06-22
		TST.B	NODEFREAD_FLAG(A6)
		BNE	READCFG_EXIT

		MOVE.W	#$0000,-(SP)
		PEA.L	DEFFILE_PATH(A6)
		DOS	_OPEN
		TST.L	D0
		BMI	READCFG_EXIT

		LEA.L	-DEFFILE_SIZE(A5),A0
		PEA.L	DEFFILE_SIZE.W
		MOVE.L	A0,-(SP)
		MOVE.W	D0,-(SP)
		DOS	_READ
		DOS	_CLOSE
		LEA.L	ENV_VELOC(A0),A0	* skip header

* xVeBx
		MOVE.B	(A0)+,LEVEL_RANGE(A6)
		MOVE.B	(A0)+,SPEA_RANGE(A6)
		MOVE.B	(A0)+,SPEA_SUM(A6)
		MOVE.B	(A0)+,SPEA_REV(A6)
		MOVE.W	(A0)+,SPEA_MODE(A6)
		MOVE.L	(A0)+,LOOP_TIME(A6)
		MOVE.W	(A0)+,INTRO_TIME(A6)

* hCoʃtF[hAEgXs[h
		LEA.L	FADE_BASE(A6),A1
		MOVE.L	(A0)+,(A1)+		* mxdrv, madrv
		MOVE.L	(A0)+,(A1)+		* mld, rcd
		MOVE.L	(A0)+,(A1)+		* zmusic, mcdrv
		MOVE.W	(A0)+,(A1)+		* faldrv

* eLXgpbg
		MOVEA.L	MMDSP_TOPADR(A6),A1
		ADDA.L	#(text_palet-_JnAhX),A1
		MOVE.L	#$200,D0
		BSR	HSCOPY

* pXLbVe  97-06-11
		LEA.L	$200(A0),A0
		LEA.L	PATH_CACHE(A6),A1
		MOVE.L	#256,D0
		BSR	HSCOPY

* tF[hAEgXs[h
		MOVE.W	DRV_MODE(A6),D0
		SUBQ.W	#1,D0
		ADD.W	D0,D0
		LEA.L	FADE_BASE(A6),A0
		MOVE.W	(A0,D0.W),MMDSP_FADE_SPD(A6)
		ST.B	DEF_READ_FLAG(A6)	* def file read flag : ON
READCFG_EXIT:
		UNLK	A5
		MOVEM.L	(SP)+,D0-D1/A0-A2
		RTS

DEF_ENVNAME:
		.DC.B	'mmdspdef',0
DEF_BASENAME:
		.DC.B	'mmdsp.def',0
		.EVEN

*	-	-	-	-	-	-	-	-	*
*	ʏݒ							*
*	-	-	-	-	-	-	-	-	*
DISP_INIT::
		MOVEM.L	D0-D7,-(SP)
		MOVEQ.L	#1,D1
		MOVEQ.L	#2,D2
		IOCS	_TGUSEMD
		MOVE.L	#$000E_0003,-(SP)
		DOS	_CONCTRL
		ADDQ.L	#4,SP
		MOVE.W	D0,FUNCMD(A6)
		MOVEQ.L	#-1,D1
		IOCS	_CRTMOD
		MOVE.W	D0,CRTMD(A6)
		LEA.L	TPALET_BLOCK0,A0	* eLXgpbgۑ
		LEA.L	TXTPALSAVE(A6),A1
		MOVEM.L	(A0),D0-D7
		MOVEM.L	D0-D7,(A1)
		CLR.W	VCTRL_R2
		MOVE.W	#$010C,D1
		IOCS	_CRTMOD
		IOCS	_OS_CUROF
		BSR	text_screen_clear
		BSR	MOUSE_INIT
		MOVEM.L	(SP)+,D0-D7
		RTS

*
* ʐݒ蕜A
*
DISP_DONE::
		MOVEM.L	D0-D7,-(SP)
		MOVE.W	CRTMD(A6),D1
		ORI.W	#$100,D1
		IOCS	_CRTMOD
		BSR	text_screen_clear
		LEA.L	TXTPALSAVE(A6),A0		* eLXgpbgA
		LEA.L	TPALET_BLOCK0,A1
		MOVEM.L	(A0),D0-D7
		MOVEM.L	D0-D7,(A1)
		MOVEQ.L	#$0E,D0
		SWAP.W	D0
		MOVE.W	FUNCMD(A6),D0
		MOVE.L	D0,-(SP)
		DOS	_CONCTRL
		ADDQ.L	#4,SP
		MOVEQ.L	#1,D1
		MOVEQ.L	#3,D2
		IOCS	_TGUSEMD
		IOCS	_MS_INIT
		IOCS	_OS_CURON
		BSR	L001254
		MOVEM.L	(SP)+,D0-D7
		RTS

*
* SAVE GRAPHIC PALET
*
SAVE_GPALET::
		MOVEM.L	D0/A0-A1,-(SP)
		LEA.L	$E82000,A0
		MOVEA.L	GTONE_TBL(A6),A1
		LEA.L	$4000(A1),A1
		MOVEQ.L	#16-1,D0
SAVE_GPALET2:
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		DBRA.W	D0,SAVE_GPALET2
		MOVEM.L	(SP)+,D0/A0-A1
		RTS

*
* RESTORE GRAPHIC PALET
*
RESUME_GPALET:
		MOVEM.L	D0/A0-A1,-(SP)
		MOVEA.L	GTONE_TBL(A6),A0
		LEA.L	$4000(A0),A0
		LEA.L	$E82000,A1
		MOVEQ.L	#16-1,D0
RESUME_GPALET2:
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		MOVE.L	(A0)+,(A1)+
		DBRA.W	D0,RESUME_GPALET2
		MOVEM.L	(SP)+,D0/A0-A1
		RTS

*
* ʕ`
*
MAKE_DISPLAY::
		BSR	SYSDISP_MAKE
		BSR	KEYBOARD_MAKE
		BSR	LEVELMETER_MAKE
		BSR	PANEL_MAKE
		BSR	SPEANA_MAKE
		BSR	SPEANA_MAKE_2
		BSR	SELECTOR_MAKE
		RTS

*==================================================
*ep̃e[u
*	QlFe[u̓e
*	PU^POi\F[hTCŶafL^J[R[h
*	R̂P	FPbyte(0-127)R̂Pɂ*2i[Ă
*	W|Urbg	F(0-255)UrbgɈk̂i[Ă
*	W|Srbg	F(0-255)SrbgɈk̂i[Ă
*	pbg	F0-31̔Zx̃pbge[u̓e(512bytes*32)
*==================================================

MAKE_TBL::
		MOVEM.L	D0-D3/A0-A1,-(SP)
		BSR	MAKE_BGTBL
		BSR	MAKE_96TO32
		BSR	MAKE_8TO6
		BSR	MAKE_8TO4
		BSR	MAKE_PALTBL
		MOVEM.L	(SP)+,D0-D3/A0-A1
		RTS

*afl\pe[u쐬

MAKE_BGTBL:
		LEA.L	BG16_TB(A6),A0
		MOVE.W	#$C80,D1
		MOVE.W	#256-1,D0
MAKE_BGTBL2:
		MOVE.W	D1,(A0)+
		ADDI.W	#$100,D1
		BTST.L	#12,D1
		BEQ	MAKE_BGTBL3
		ADDQ.B	#1,D1
MAKE_BGTBL3:
		ANDI.W	#$0FFF,D1
		ORI.W	#$0C00,D1
		DBRA.W	D0,MAKE_BGTBL2

		LEA.L	BG16_TB(A6),A0
		LEA.L	BG10_TB(A6),A1
		MOVEQ.L	#10-1,D0
MAKE_BGTBL4:
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		MOVE.W	(A0)+,(A1)+
		LEA.L	12(A0),A0
		DBRA.W	D0,MAKE_BGTBL4
		RTS

*P^Re[u쐬

MAKE_96TO32:
		LEA.L	FROM96_TO32(A6),A0
		MOVEQ.L	#$FF,D1
		MOVEQ.L	#(129/3)-1,D0
MAKE_96TO32_2:
		MOVE.B	D1,(A0)+
		MOVE.B	D1,(A0)+
		MOVE.B	D1,(A0)+
		DBRA.W	D0,MAKE_96TO32_2

		LEA.L	FROM96_TO32(A6),A0
		MOVEQ.L	#0,D1
		MOVEQ.L	#32+10-1,D0
MAKE_96TO32_3:
		MOVE.B	D1,(A0)+
		MOVE.B	D1,(A0)+
		MOVE.B	D1,(A0)+
		ADDQ.B	#2,D1
		DBRA.W	D0,MAKE_96TO32_3
		RTS

*WUhbgϊe[u쐬

MAKE_8TO6:
		LEA.L	TO6BIT_TBL(A6),A0
		MOVEQ.L	#0,D2
MAKE_8TO6_2:
		MOVE.B	D2,D0
		MOVE.B	D0,D1
		ADD.B	D0,D0
		ANDI.B	#%1000_1000,D1
		OR.B	D0,D1

		ANDI.B	#%1110_1110,D1
		MOVE.B	D1,D0
		ADD.B	D1,D1

		ANDI.B	#%1110_0000,D0
		ANDI.B	#%0001_1100,D1
		OR.B	D1,D0

		MOVE.B	D0,(A0)+
		ADDQ.B	#1,D2
		BCC	MAKE_8TO6_2
		RTS

*WShbgϊe[u쐬

MAKE_8TO4:
		LEA.L	TO4BIT_TBL(A6),A0
		MOVEQ.L	#0,D2
MAKE_8TO4_2:
		MOVE.B	D2,D1
		ADD.B	D1,D1
		OR.B	D2,D1
		MOVEQ.L	#0,D0
		ROXR.B	#2,D1
		ROXR.B	#1,D0
		ROXR.B	#2,D1
		ROXR.B	#1,D0
		ROXR.B	#2,D1
		ROXR.B	#1,D0
		ROXR.B	#2,D1
		ROXR.B	#1,D0
		MOVE.B	d0,D1
		ROR.B	#4,D1
		OR.B	D1,D0
		MOVE.B	D0,(A0)+
		ADDQ.B	#1,D2
		BCC	MAKE_8TO4_2
		RTS

*pbge[u쐬

*pbgʌvZ
*	d1.w <- tone(0-31)
*	d2.w <- palet low(0-255)
*	a1.l <- Ze[u
*	d3.b -> toned palet low

GTONE_CALC_LOW:	.MACRO
		MOVEQ.L	#$3E,D3			*BLUE (I͖)
		AND.W	D2,D3
		LSR.W	#1,D3
		MOVE.B	(A1,D3.W),D3
		ADD.B	D3,D3
		MOVE.W	D2,D0			*RED LOW
		ROL.B	#2,D0
		ANDI.W	#$0003,D0
		MOVE.B	(A1,D0.W),D0
		ROR.B	#2,D0
		OR.B	D0,D3
		.ENDM

*pbgʌvZ
*	d1.w <- tone(0-31)
*	d2.w <- palet hi(0-255)
*	a1.l <- Ze[u
*	d3.b -> toned palet hi

GTONE_CALC_HI:	.MACRO
		MOVEQ.L	#$07,D3			*RED HI
		AND.W	D2,D3
		MOVE.B	(A1,D3.W),D3
		MOVE.W	D2,D0			*GREEN
		LSR.W	#3,D0
		MOVE.B	(A1,D0.W),D0
		LSL.B	#3,D0
		OR.B	D0,D3
		.ENDM

MAKE_PALTBL:
		LINK	A5,#-40

		LEA.L	GTONE_BUF(A6),A0
		MOVE.L	A0,GTONE_TBL(A6)

		MOVEQ.L	#0,D0
		MOVEQ.L	#(512/16)-1,D1
MAKE_PALTBL2:
		MOVE.L	D0,(A0)+
		MOVE.L	D0,(A0)+
		MOVE.L	D0,(A0)+
		MOVE.L	D0,(A0)+
		DBRA.W	D1,MAKE_PALTBL2

		MOVEQ.L	#2,D1
MAKE_PALTBL3:
		MOVEA.L	SP,A1
		CLR.B	(A1)+
		MOVEQ.L	#1,D2
		MOVEQ.L	#31-1,D3
MAKE_PALTBL4:
		MOVE.W	D1,D0
		MULU.W	D2,D0
		LSR.W	#5,D0
		MOVE.B	D0,(A1)+
		ADDQ.W	#1,D2
		DBRA.W	D3,MAKE_PALTBL4

		MOVEQ.L	#0,D2
		MOVEA.L	SP,A1
MAKE_PALTBL5:
		GTONE_CALC_LOW
		MOVE.B	D3,(A0)+
		ORI.B	#1,D3
		MOVE.B	D3,(A0)+
		GTONE_CALC_HI
		MOVE.B	D3,(A0)+
		ADDQ.B	#1,D2
		GTONE_CALC_HI
		MOVE.B	D3,(A0)+
		ADDQ.B	#1,D2
		BNE	MAKE_PALTBL5
		ADDQ.W	#1,D1				*PxRQ܂ŌJԂ
		CMPI.W	#32,D1
		BLS	MAKE_PALTBL3

		UNLK	A5
		RTS

*==================================================
*ÑJgpXۑ
*==================================================

SAVE_CURRENT::
		MOVE.L	A0,-(SP)
		LEA.L	(A6),A0
		BSR	GET_CURRENT
		MOVE.L	(SP)+,A0
		RTS

*==================================================
*w̃pXֈړ
*==================================================

MOVE_CURRENT::
		MOVE.L	A0,-(SP)
		LEA.L	CURRENT(A6),A0
		TST.B	(A0)
		BEQ	MOVE_CURRENT2
		BSR	SET_CURRENT
MOVE_CURRENT2:
		MOVE.L	(SP)+,A0
		RTS

*==================================================
*ÑJgpX𕜋A
*==================================================

RESUME_CURRENT::
		MOVE.L	A0,-(SP)
		LEA.L	(A6),A0
		BSR	SET_CURRENT
		MOVE.L	(SP)+,A0
		RTS

*==================================================
*N̉ʂۑ
*	d0.l -> -1:ʃ[hNɂ͕sK
*==================================================

SAVE_DISPLAY::
		MOVEM.L	D1-D2/A0-A1,-(SP)
		MOVEQ.L	#-1,D1
		MOVEQ.L	#-1,D2
		IOCS	_B_LOCATE
		MOVE.L	D0,LOCATESAVE(A6)

* R\[͈͂̕ۑ from v0.30 97-04-22
		MOVEQ.L	#-1,D1
		MOVE.L	D1,D2
		IOCS	_B_CONSOL
		MOVEM.L	D1-D2,CONSOLSAVE(A6)

		MOVE.B	$992.W,CURSORSAVE(A6)
		IOCS	_OS_CUROF
		LEA.L	CRTC_R21,A0
		MOVE.W	(A0),-(SP)
		CLR.W	(A0)
		LEA.L	$E00000,A0
		LEA.L	$E50000,A1
		MOVEQ.L	#1,D0			* MOVE.L #$10000,D0
		SWAP.W	D0
		BSR	HSCOPY
		LEA.L	$E20000,A0
		LEA.L	$E70000,A1
		BSR	HSCOPY
		MOVE.W	(SP)+,CRTC_R21
		MOVE.W	CRTC_R20,CRTCMODE_SAVE(A6)
		MOVE.W	CRTC_R21,CRTCACM_SAVE(A6)
		MOVE.W	VCTRL_R0,VIDEOMODE_SAVE(A6)
		MOVE.W	VCTRL_R1,VIDEOPRIO_SAVE(A6)
		MOVE.W	VCTRL_R2,VIDEOEFF_SAVE(A6)
		MOVE.W	$EB0808,BGCTRL_SAVE(A6)
		BSR	SAVE_GPALET
		MOVE.L	GRPH_1LINE_BYTES.W,IOCSXLEN_SAVE(A6)
		MOVE.W	GRPH_SCR_COLOR.W,IOCSGMODE_SAVE(A6)
		MOVE.L	GRPH_CLIP_XY_MIN.W,IOCSWIN_SAVE1(A6)
		MOVE.L	GRPH_CLIP_XY_MAX.W,IOCSWIN_SAVE2(A6)
		MOVEQ.L	#-1,D1
		IOCS	_APAGE
		MOVE.B	D0,APAGE_SAVE(A6)
		MOVEQ.L	#-1,D1
		IOCS	_VPAGE
		MOVE.B	D0,VPAGE_SAVE(A6)
		MOVEQ.L	#0,D0
		MOVEM.L	(SP)+,D1-D2/A0-A1
		RTS

*==================================================
*NỎʂČ
*==================================================

RESUME_DISPLAY::
		MOVEM.L	D1-D2/A0-A1,-(SP)
		MOVE.W	CRTCMODE_SAVE(A6),CRTC_R20
		MOVE.W	CRTCACM_SAVE(A6),CRTC_R21
		MOVE.W	VIDEOMODE_SAVE(A6),VCTRL_R0
		MOVE.W	VIDEOPRIO_SAVE(A6),VCTRL_R1
		MOVE.W	VIDEOEFF_SAVE(A6),VCTRL_R2
		MOVE.W	BGCTRL_SAVE(A6),$EB0808
		MOVE.L	IOCSXLEN_SAVE(A6),GRPH_1LINE_BYTES.W
		MOVE.W	IOCSGMODE_SAVE(A6),GRPH_SCR_COLOR.W
		MOVE.L	IOCSWIN_SAVE1(A6),GRPH_CLIP_XY_MIN.W
		MOVE.L	IOCSWIN_SAVE2(A6),GRPH_CLIP_XY_MAX.W
		MOVE.B	APAGE_SAVE(A6),D1
		IOCS	_APAGE
		MOVE.B	VPAGE_SAVE(A6),D1
		IOCS	_VPAGE
		BSR	RESUME_GPALET

* R\[͈͂̕A from v0.30 97-04-22
		MOVEM.L	CONSOLSAVE(A6),D1-D2
		IOCS	_B_CONSOL

		MOVE.L	LOCATESAVE(A6),D2
		MOVE.L	D2,D1
		SWAP.W	D1
		IOCS	_B_LOCATE
		IOCS	_OS_CUROF
		LEA.L	CRTC_R21,A0
		MOVE.W	(A0),-(SP)
		CLR.W	(A0)
		LEA.L	$E50000,A0
		LEA.L	$E00000,A1
		MOVEQ.L	#1,D0			* MOVE.L #$10000,D0
		SWAP.W	D0
		BSR	HSCOPY
		LEA.L	$E70000,A0
		LEA.L	$E20000,A1
		BSR	HSCOPY
		MOVE.W	(SP)+,CRTC_R21
		TST.B	CURSORSAVE(A6)
		BEQ	L000c56
		IOCS	_OS_CURON
L000c56:
		MOVEM.L	(SP)+,D1-D2/A0-A1
		RTS

*============================================================
*f[^][`
*	in	d0.l	f[^̃oCg
*		a0	]AhX(΋)
*		a1	]AhX(   V   )
*============================================================

HSCOPY_W::
		WAIT_VDISP
HSCOPY::
		MOVEM.L	D0-D7/A0-A3,-(SP)
		MOVE.L	D0,D1
		CMPA.L	A0,A1
		BHI	HSCOPY_RF
		BEQ	HSCOPY_EXIT
		ANDI.W	#$7F,D0
		LSR.L	#7,D1
		BRA	HSCOPY3
HSCOPY2:
		MOVEM.L	(A0)+,D2-D7/A2-A3
		MOVEM.L	D2-D7/A2-A3,$00(A1)
		MOVEM.L	(A0)+,D2-D7/A2-A3
		MOVEM.L	D2-D7/A2-A3,$20(A1)
		MOVEM.L	(A0)+,D2-D7/A2-A3
		MOVEM.L	D2-D7/A2-A3,$40(A1)
		MOVEM.L	(A0)+,D2-D7/A2-A3
		MOVEM.L	D2-D7/A2-A3,$60(A1)
		LEA.L	$80(A1),A1
HSCOPY3:
		SUBQ.L	#1,D1
		BCC	HSCOPY2
		BRA	HSCOPY5
HSCOPY4:
		MOVE.B	(A0)+,(A1)+
HSCOPY5:
		DBRA.W	D0,HSCOPY4
		BRA	HSCOPY_EXIT
HSCOPY_RF:
		ADDA.L	D0,A0
		ADDA.L	D0,A1
		ANDI.W	#$7F,D0
		LSR.L	#7,D1
		BRA	HSCOPY_RF3
HSCOPY_RF2:
		MOVE.B	-(A0),-(A1)
HSCOPY_RF3:
		DBRA.W	D0,HSCOPY_RF2
		BRA	HSCOPY_RF5
HSCOPY_RF4:
		LEA.L	-$80(A0),A0
		MOVEM.L	$60(A0),D2-d7/A2-A3
		MOVEM.L	D2-D7/A2-A3,-(A1)
		MOVEM.L	$40(A0),D2-d7/A2-A3
		MOVEM.L	D2-D7/A2-A3,-(A1)
		MOVEM.L	$20(A0),D2-d7/A2-A3
		MOVEM.L	D2-D7/A2-A3,-(A1)
		MOVEM.L	(A0),D2-d7/A2-A3
		MOVEM.L	D2-D7/A2-A3,-(A1)
HSCOPY_RF5:
		SUBQ.L	#1,D1
		BCC	HSCOPY_RF4
HSCOPY_EXIT:
		MOVEM.L	(SP)+,D0-D7/A0-A3
		RTS

*============================================================
*NA[`
* in	d0.l	NATCY
*	a0.l	NAAhX
*============================================================

HSCLR_W::
		WAIT_VDISP
HSCLR::
		MOVEM.L	D0-D7/A0-A2,-(SP)
		MOVEQ.L	#0,D2
		MOVE.L	D2,D3
		MOVE.L	D2,D4
		MOVE.L	D2,D5
		MOVE.L	D2,D6
		MOVE.L	D2,D7
		MOVEA.L	D2,A1
		MOVEA.L	D2,A2
		ADDA.L	D0,A0
		MOVEQ.L	#$7F,D1
		AND.W	D0,D1
		LSR.W	#1,D1
		BCC	HSCLR3
		MOVE.B	D2,-(A0)
		BRA	HSCLR3
HSCLR2:
		MOVE.W	D2,-(A0)
HSCLR3:
		DBRA.W	D1,HSCLR2
		LSR.L	#7,D0
		BRA	HSCLR5
HSCLR4:
		MOVEM.L	D2-D7/A1-A2,-(A0)
		MOVEM.L	D2-D7/A1-A2,-(A0)
		MOVEM.L	D2-D7/A1-A2,-(A0)
		MOVEM.L	D2-D7/A1-A2,-(A0)
HSCLR5:
		DBRA.W	D0,HSCLR4
		ADDQ.W	#1,D0
		SUBQ.L	#1,D0
		BCC	HSCLR4
		MOVEM.L	(SP)+,D0-D7/A0-A2
		RTS

*
* CONTRAST INITIALIZE
*
CONTRAST_INIT::
		MOVEQ.L	#-1,D1
		IOCS	_CONTRAST
		MOVE.W	D0,ORIG_CONTRAST(A6)
		MOVE.L	#10140,NO_KEYINSEC(A6)		* ((180*60)*95/100)-120
		MOVE.W	#5,CONTRAST_NUM(A6)
		RTS



TITLE:
		.dc.b	'X68k multi music status display MMDSP.r v0.29 ',RELNUM
		.dc.b	' (c)1991-94 Miahmie, Gao',CRLF
		.dc.b	9,9,9,9,9,'    Modified (c)1995-97 Fu-., BEL.',CRLF
.ifdef PATCHLEVEL
		.dc.b	9,9,9,9,'      patchlevel ',PATCHLEVEL,' : ',PATCHDATE,' ',PATCHAUTHOR,'.',CRLF
.endif
		.dc.b	0

USAGE_MES:
		.dc.b	'ygp@zmmdsp [IvV] [fBNg/tt@C]',CRLF
		.dc.b	'	-<name>		hCow',CRLF
		.dc.b	'	-g[n]		OtBbN\[h(n:0-3)',CRLF
		.dc.b	'	-a[bbbb]	AUTO[h',CRLF
		.dc.b	'	-s[bbbb]	SHUFFLE[h',CRLF
		.dc.b	'	-n		ZN^gpȂ',CRLF
.ifdef PRINT_F_OPTION
		.dc.b	'	-f		eLXggp[h',CRLF
.endif
		.dc.b	'	-k[key1,key2]	풓',CRLF
		.dc.b	'	-r		풓',CRLF
		.dc.b	'	-t[sec]		ʃg[_E܂ł̕b',CRLF
		.dc.b	'	-c[n]		ʃg[_E̖邳(n:0-15)',CRLF
		.dc.b	'	-i[n]		gp銄荞݂w(n:1-4)',CRLF
		.dc.b	'	-p		pbgAj[VgpȂ',CRLF
		.dc.b	'	-nodef		`t@Cǂݍ܂ȂŋN',CRLF
		.dc.b	CRLF

		.dc.b	'	<name>  -mxdrv -madrv -mld -rcd -zmusic -mcdrv ̂ꂩ'
		.dc.b	CRLF
		.dc.b	'	REP. INTRO ALLDIR PROG.  on/off  [bbbb] ɃrbgŎw'
		.dc.b	'(ex:-a1010)',CRLF
		.dc.b	'	[key1,key2] ͋NL[̃R[h(def: XF4+XF5)',CRLF
		.dc.b	CRLF
		.dc.b	'	ϐ mmdspcmd ̓eR}hC̍Ōɒǉ܂'
		.dc.b	CRLF,0

MEMORY_MES:
		.dc.b	'܂.',CRLF,0

.ifdef HUMAN_VERSION_CHECK
OSERR_MES:
		.dc.b	'Human v3.0ȏŋNĉ.',CRLF,0
.endif
*
TIMERA_MES:
		.dc.b	'TIMER-A',0
RASTER_MES:
		.dc.b	'CRTC RASTER',0
VDISP_MES:
		.dc.b	'V-DISP',0
TIMERD_MES:
		.dc.b	'TIMER-D',0

INTERRUPT_MES:
		.dc.b	'荞݂gp܂.',CRLF,0
MODE_MES:
		.dc.b	'[hŋN܂.',CRLF,0

DESIGNATED_MES:
		.dc.b	'w肳ꂽ'
DRIVER_MES:
		.dc.b	'hCogݍ܂ĂȂAΉĂȂo[Wł.'
		.dc.b	CRLF,CRLF
		.dc.b	'yΉhCoуo[Wꗗz',CRLF
		.dc.b	'	mxdrv	v2.06+16 ȏ',CRLF
		.dc.b	'	madrv	v1.09o ȏ',CRLF
		.dc.b	'	rcd	v3.00 ȏ',CRLF
		.dc.b	'	mld	v2.36 ȏ',CRLF
		.dc.b	'	Z-Music	v1.43 ȏ(v3.00ȍ~Ή)',CRLF
		.dc.b	'	MCDRV	v0.19 ȏ',CRLF
		.dc.b	'	faldrv	v2.9 ȏ',CRLF
		.dc.b	'	mndrv	v0.65 ȏ',CRLF
		.dc.b	CRLF,0

TEXT_MES:
		.dc.b	'TEXT-VRAMAvP[VɂgpĂ܂.',CRLF
.ifdef PRINT_F_OPTION
		.dc.b	'gp鎞́A-f IvVw肵Ă.',CRLF
.endif
		.dc.b	0

NOINT_MES:
		.dc.b	'gp\Ȋ荞݂܂.',CRLF,0



		.END
